package mypkg.lambda;

import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;

/**
 *  -- LExprγĥ饹
 *
 * Ȥ
 *     ѿ |  | ؿŬ
 * Ǥ, Υ饹ϥݤɽ.
 *
 * ݤȤϥץߥ󥰸ѸȤдؿΤȤǤ.
 * ݤŪɽ
 *     x.M
 * Ȥʤ. 
 *     x: «ѿ̾
 *     M: ؿΤɽ
 * Ȥ.
 *
 * Υ饹Υ֥Ȥϥĥ꡼ɽΥΡɤȤʤ.
 */
public class Abstraction extends LExpr {

	private String parameter;  // «ѿ̾ ()
	private LExpr expression;  //  (ؿ)

	// ȥ졼Υ
	protected static final String
		REDEX    = "(x.M)NM[x:=N]",
		ABS_STEP = "x.Mx.N if MN",
		ETA_STEP = "x.MxM (eta)";

	/**
	 * 󥹥ȥ饯
	 *
	 * @param parameter  «ѿ̾
	 * @param expression 
	 */
	public Abstraction(String parameter, LExpr expression) {
		if (!checkVariable(parameter))
			throw new IllegalArgumentException("invalid param: " + parameter);
		this.parameter = parameter;
		this.expression = expression;
	}

	/**
	 * Υ֥ȤΥԡ֤.
	 */
	public Object clone() {
		Abstraction newexpr = null;
		try {
			newexpr = (Abstraction)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.parameter = this.parameter;
		newexpr.expression = (LExpr)this.expression.clone();
		return newexpr;
	}

	/**
	 * Υ֥Ȥ x.M ʤФβ̾ x ֤.
	 */
	protected String parameterName() {
		return parameter;
	}

	/**
	 * Υ֥Ȥ x.M ʤФδؿ M ֤.
	 */
	protected LExpr getBody() {
		return expression;
	}

	/**
	 * ͳѿ򽸤.
	 */
	protected void gatherFreeVars(Set set) {
		expression.gatherFreeVars(set);
		set.remove(parameter);
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N ͤ M 
	 *     ѿ, , ؿŬ
	 * ξʬƵ.
	 *  (ץߥ󥰸δ ٽ p.18)
	 *
	 *                                   
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  嵭ʳ            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N μͳѿǤϤʤȤ̣.
	 *  [2] ưŪ˦Ѵ뤳Ȥ. ѿ z Ϥޤä̾
	 *        Ф.
	 *
	 * פʦѴϤǤ򤱤̤򤷤䤹.
	 * äƿѿФuniqueVariable()θƤӽФ򾯤ʤ
	 * 르ꥺϽפǤ.
	 *
	 * @param param ѿ (x)
	 * @param arg   ° (N)
	 * @param level ƵƽФ٥
	 * @return  黻̤
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		LExpr value = null;
		if (param.equals(parameter)) {
			//########## (c) (y.M)[x:=N]  y.M ##########
			value = new Abstraction(parameter, expression);
		} else if (paramAvailable(this, param, arg)) {
			/*
			 * Τ褦ʾ.
			 *     (x.y.x)y.z -> y.y.z
			 * Ϥ֤ǤѴ٤Ǥ.
			 */
			//########## (d) (y.M)[x:=N]  y.M[x:=N] ##########
			LExpr expr = expression.substitute(param, arg, level+1);
			value = new Abstraction(parameter, expr);
		} else {
			//########## (e) (y.M)[x:=N]  z.M[y:=z][x:=N] ##########
			// ưŪ˦ѴԤ.
			LExpr var = LExpr.uniqueVariable();
			LExpr expr = expression.substitute(parameter, var, level+1);
			LExpr nexpr = expr.substitute(param, arg, level+1);
			value = new Abstraction(var.variableName(), nexpr);
		}
		return value;
	}

	/**
	 * Σƥå״ -- -redexξ
	 * -redexȤ(x.M)NηΥ̣.
	 * Υ᥽åɤоݤ x.M Ǥ arg  N ȤƸƤӽФ.
	 */
	protected LExpr reduceRedex(LExpr arg, int level) {
		//########## (A) (x.M)N  M[x:=N] ##########
		LExpr value = expression.substitute(parameter, arg, level);
		TraceInfo trinf = TraceInfo.getInstance();
		if (trinf.isVerbose()) {
			LExpr redex = getInstance(expression, parameter, arg);
			trinf.appendRedex(redex, level, REDEX);
		}
		return value;
	}

	/**
	 * Σƥå׺Ǻ -- Ѵ
	 * Υ᥽åɤϺǺ󤵤줿򣱸֤.
	 *
	 * Ѵ (׻ ⶶ p.65)
	 * 梪ϦѴ̣ΤȤ.
	 *
	 *        §                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N ʤ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N ʤ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N ʤ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * ȤФΥ֥(this)
	 *     ((a.b)c)((x.y)z)
	 * Ȥ
	 *     b((x.y)z)
	 * ֤.
	 *
	 * @param level ƵƽФ٥
	 * @return  ƥå׺Ǻ̤Υ (Ǥʤnull)
	 */
	protected LExpr reduce(int level) {
		//########## (B) M  N ʤ x.M  x.N ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (!noEtaConversion) {
			LExpr value = this.etaConversion(null);
			if (value != null) {
				if (verbose)
					trinf.appendTarget(this, level+1, ETA_STEP);
				return value;
			}
		}
		if (verbose) {
			trinf = trinf.push();
			if (expression.variableName() == null)
				trinf.appendTarget(expression, level+1, ABS_STEP);
		}
		LExpr expr = expression.reduce(level+1);
		if (verbose) {
			trinf.appendResult(expr, level+1, ABS_STEP);
			trinf.pop(expr != null);
		}
		if (expr != null) {
			//  M δ̤ݲ.
			return new Abstraction(parameter, expr);
		}
		return null;
	}

	/**
	 * Σƥå״ -- Ѵ
	 * Υ᥽åɤϺǺǤϤʤ٤Ƥδ̤֤.
	 *
	 * Ѵ (׻ ⶶ p.65)
	 * 梪ϦѴ̣ΤȤ.
	 *
	 *        §                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N ʤ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N ʤ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N ʤ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * ƥå״η̤ʣΤ, Υ᥽åɤList<LExpr>
	 * ֤ͤ. ȤФΥ֥(this)
	 *     ((a.b)c)((x.y)z)
	 * Ȥ
	 *     [b((x.y)z); ((a.b)c)y]
	 * ֤.
	 *
	 * ̤ʣϺǺƬǤȤʤ륢르ꥺȤʤä
	 * . ä뤿ˤΥ᥽åɤƤӽФϺǺ
	 * ̵̤ʷ׻άǤ.
	 * ٤Ƥδ̤뵡ǽ, ήǧ, ˡˤä
	 * ߤʤȤʤɤǧ뤿ѰդƤ.
	 *
	 * @param level ƵƽФ٥
	 * @return  ƥå״̤Υꥹ
	 */
	protected List reduceAll(int level) {
		//########## (B) M  N ʤ x.M  x.N ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (!noEtaConversion) {
			LExpr value = this.etaConversion(null);
			if (value != null) {
				List list = new ArrayList();
				appendLExpr(list, value);
				if (verbose)
					trinf.appendTarget(this, level+1, ETA_STEP);
				return list;
			}
		}
		if (verbose && expression.variableName() == null)
			trinf.appendTarget(expression, level+1, ABS_STEP);
		List list = expression.reduceAll(level+1);
		if (verbose)
			trinf.appendList(list, level+1, ABS_STEP);
		for (int n = 0; n < list.size(); n++) {
			//  M δ̤ݲ.
			list.set(n, new Abstraction(parameter, (LExpr)list.get(n)));
		}
		return list;
	}

	/**
	 * ưŪʦѴɬפɤĴ٤.
	 * Ȥ
	 *     (x.y.x)y.z
	 * η׻Ǥ
	 *     body=y.x  param=x  arg=y.z
	 * ξǤΥ᥽åɤƤӽФ. true֤
	 *     y.y.z
	 * ȤʤäƤޤ.
	 *
	 * @param body ؿΤ (Abstraction˸¤)
	 * @param param ѿ
	 * @param arg °
	 * @return Ѵɬפʤtrue
	 */
	private boolean paramAvailable(Abstraction body, String param, LExpr arg) {
		String bodyparam = body.parameter;
		LExpr bodyexpr = body.expression;
		if (param.equals(bodyexpr.variableName())) {
			for (LExpr e = arg; e instanceof Abstraction; ) {
				if (bodyparam.equals(((Abstraction)e).parameter))
					return false;  // Ѵɬ
				e = ((Abstraction)e).expression;
			}
		}
		return !arg.freeVariables().contains(bodyparam);
	}

	/**
	 * Υ֥ȤΥ֥ȤȦƱͤʤtrue֤.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		if (!(expr instanceof Abstraction))
			return false;
		Abstraction abs = (Abstraction)expr;
		LExpr body = abs.expression;
		if (expression.getClass() != body.getClass())
			return false;
		/*
		 * б«ѿФ򥹥åѤ.
		 */
		stack.addFirst(new String[]{parameter, abs.parameter});
		boolean result = expression.isEquivalent(body, stack, level);
		stack.removeFirst();
		return result;
	}

	/**
	 * Ѵ
	 *     (x.Mx)N = MN  x ! FV(M)
	 * Ǥ뤳Ȥθ
	 *     x.Mx = M
	 * ֤ǽǤ.
	 */
	protected LExpr etaConversion(String param) {
		if (expression.getFunction() != null)
			return expression.etaConversion(parameter);
		return null;
	}

	/**
	 * Υ֥ȤChurchʤп֤ͤ.
	 * Ǥʤ IllegalStateException 򥹥.
	 * Υ饹Ǥϰ򻲾Ȥʤ.
	 */
	protected int getChurchNumeral(String succ, String zero) {
		if (!(expression instanceof Abstraction))
			throw new IllegalStateException();
		Abstraction body = (Abstraction)expression;
		succ = parameter;
		zero = body.parameter;
		return body.expression.getChurchNumeral(succ, zero);
	}

	/**
	 * ǤʷʿŪɽʸ֤.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		String lambda = uselambda ? LAMBDA : "\\";
		String body = expression.toAbbrevString(uselambda);
		StringBuffer sb = new StringBuffer();
		sb.append(lambda).append(parameter).append(".").append(body);
		return sb.toString();
	}

	/**
	 * ʷʿŪɽʸ֤.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		String lambda = uselambda ? LAMBDA : "\\";
		String body = expression.toMathString(uselambda);
		StringBuffer sb = new StringBuffer();
		sb.append(lambda).append(parameter).append(".").append(body);
		return sb.toString();
	}

	/**
	 * ĹʿŪɽʸ֤.
	 *  x.(y.(z.((xy)z)))
	 */
	protected String toProperString(boolean uselambda) {
		String lambda = uselambda ? LAMBDA : "\\";
		StringBuffer sb = new StringBuffer();
		sb.append(lambda).append(parameter).append(".");
		sb.append(parenthesize(expression.toProperString(uselambda)));
		return sb.toString();
	}

	/**
	 * ͳѿ«ѿ̤٤Ƥѿ򽸤.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void gatherVars(Set set) {
		set.add(parameter);
		expression.gatherVars(set);
	}

	/**
	 * бɽ򻲾Ȥѿ֤̾.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void replaceVars(Map map) {
		String newparam = (String)map.get(parameter);
		if (newparam != null)
			parameter = newparam;
		expression.replaceVars(map);
	}
}
