package mypkg.lambda;

import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;

/**
 * ؿŬ -- LExprγĥ饹
 *
 * Ȥ
 *     ѿ |  | ؿŬ
 * Ǥ, Υ饹ϴؿŬѤɽ.
 *
 * ؿŬѤȤϥץߥ󥰸ѸȤдؿƽФ.
 * ؿŬѤŪɽ
 *     MN
 * Ȥʤ.  M, N ǤդΥȤ.
 * ؿŬѤϺŪǤ. Ĥޤ LMN  (LM)N ΰ̣Ǥ.
 *
 * Υ饹Υ֥Ȥϥĥ꡼ɽΥΡɤȤʤ.
 */
public class Application extends LExpr {

	// 󥹥ѿ̾ left, right ϥĥ꡼ΡɤꤷƤ.

	private LExpr left;   // ؿŬѥ1
	private LExpr right;  // ؿŬѥ2

	// ȥ졼Υ
	protected static final String
		E1_STEP  = "MPNP if MN",
		E2_STEP  = "PMPN if MN";

	/**
	 * 󥹥ȥ饯
	 *
	 * @param left  ؿŬѥ1
	 * @param right ؿŬѥ2
	 */
	public Application(LExpr left, LExpr right) {
		this.left = left;
		this.right = right;
	}

	/**
	 * Υ֥ȤΥԡ֤.
	 */
	public Object clone() {
		Application newexpr = null;
		try {
			newexpr = (Application)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.left = (LExpr)this.left.clone();
		newexpr.right = (LExpr)this.right.clone();
		return newexpr;
	}

	/**
	 * Υ֥ȤؿŬ MN ʤФδؿ M ֤.
	 */
	protected LExpr getFunction() {
		return left;
	}

	/**
	 * Υ֥ȤؿŬ MN ʤФΰ N ֤.
	 */
	protected LExpr getArgument() {
		return right;
	}

	/**
	 * ͳѿ򽸤.
	 */
	protected void gatherFreeVars(Set set) {
		left.gatherFreeVars(set);
		right.gatherFreeVars(set);
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N ͤ M 
	 *     ѿ, , ؿŬ
	 * ξʬƵ.
	 *  (ץߥ󥰸δ ٽ p.18)
	 *
	 *                                   
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  嵭ʳ            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N μͳѿǤϤʤȤ̣.
	 *  [2] ưŪ˦Ѵ뤳Ȥ. ѿ z Ϥޤä̾
	 *        Ф.
	 *
	 * @param param ѿ (x)
	 * @param arg   ° (N)
	 * @param level ƵƽФ٥
	 * @return  黻̤
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		//########## (f) (M1M2)[x:=N]  M1[x:=N]M2[x:=N] ##########
		LExpr lexpr = left.substitute(param, arg, level+1);
		LExpr rexpr = right.substitute(param, arg, level+1);
		return new Application(lexpr, rexpr);
	}

	/**
	 * Υ֥ȤΥ֥ȤȦƱͤʤtrue֤.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		if (!(expr instanceof Application))
			return false;
		Application app = (Application)expr;
		return left.isEquivalent(app.left, stack, level)
			&& right.isEquivalent(app.right, stack, level);
	}

	/**
	 * Ѵ
	 *     (x.Mx)N = MN  x ! FV(M)
	 * Ǥ뤳Ȥθ
	 *     x.Mx = M
	 * ֤ǽǤ.
	 */
	protected LExpr etaConversion(String param) {
		if (param.equals(right.variableName()))
			if (!left.freeVariables().contains(param))
				return left;
		return null;
	}

	/**
	 * Σƥå׺Ǻ -- Ѵ
	 * Υ᥽åɤϺǺ󤵤줿򣱸֤.
	 *
	 * Ѵ (׻ ⶶ p.65)
	 * 梪ϦѴ̣ΤȤ.
	 *
	 *        §                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N ʤ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N ʤ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N ʤ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * ȤФΥ֥(this)
	 *     ((a.b)c)((x.y)z)
	 * Ȥ
	 *     b((x.y)z)
	 * ֤.
	 *
	 * @param level ƵƽФ٥
	 * @return  ƥå׺Ǻ̤Υ (Ǥʤnull)
	 */
	protected LExpr reduce(int level) {
		if (left.getBody() != null) {
			//########## (A) (x.M)N  M[x:=N] ##########
			return left.reduceRedex(right, level+1);
		}
		//########## (C) M  N ʤ MP  NP ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (verbose) {
			trinf = trinf.push();
			if (left.variableName() == null)
				trinf.appendTarget(left, level+1, E1_STEP);
		}
		LExpr expr1 = left.reduce(level+1);
		if (verbose) {
			trinf.appendResult(expr1, level+1, E1_STEP);
			trinf.pop(expr1 != null);
		}
		if (expr1 != null)
			return new Application(expr1, right);
		//########## (D) M  N ʤ PM  PN ##########
		if (verbose) {
			trinf = trinf.push();
			if (right.variableName() == null)
				trinf.appendTarget(right, level+1, E2_STEP);
		}
		LExpr expr2 = right.reduce(level+1);
		if (verbose) {
			trinf.appendResult(expr2, level+1, E2_STEP);
			trinf.pop(expr2 != null);
		}
		if (expr2 != null)
			return new Application(left, expr2);
		return null;
	}

	/**
	 * Σƥå״ -- Ѵ
	 * Υ᥽åɤϺǺǤϤʤ٤Ƥδ̤֤.
	 *
	 * Ѵ (׻ ⶶ p.65)
	 * 梪ϦѴ̣ΤȤ.
	 *
	 *        §                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N ʤ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N ʤ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N ʤ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * ƥå״η̤ʣΤ, Υ᥽åɤList<LExpr>
	 * ֤ͤ. ȤФΥ֥(this)
	 *     ((a.b)c)((x.y)z)
	 * Ȥ
	 *     [b((x.y)z); ((a.b)c)y]
	 * ֤.
	 *
	 * ̤ʣϺǺƬǤȤʤ륢르ꥺȤʤä
	 * . ä뤿ˤΥ᥽åɤƤӽФϺǺ
	 * ̵̤ʷ׻άǤ.
	 * ٤Ƥδ̤뵡ǽ, ήǧ, ˡˤä
	 * ߤʤȤʤɤǧ뤿ѰդƤ.
	 *
	 * @param level ƵƽФ٥
	 * @return  ƥå״̤Υꥹ
	 */
	protected List reduceAll(int level) {
		List list = new ArrayList();
		if (left.getBody() != null) {
			//########## (A) (x.M)N  M[x:=N] ##########
			appendLExpr(list, left.reduceRedex(right, level+1));
		}
		//########## (C) M  N ʤ MP  NP ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (verbose && left.variableName() == null)
			trinf.appendTarget(left, level+1, E1_STEP);
		List list1 = left.reduceAll(level+1);
		if (verbose)
			trinf.appendList(list1, level+1, E1_STEP);
		for (int n = 0; n < list1.size(); n++) {
			appendLExpr(list, new Application((LExpr)list1.get(n), right));
		}
		//########## (D) M  N ʤ PM  PN ##########
		if (verbose && right.variableName() == null)
			trinf.appendTarget(right, level+1, E2_STEP);
		List list2 = right.reduceAll(level+1);
		if (verbose)
			trinf.appendList(list2, level+1, E2_STEP);
		for (int n = 0; n < list2.size(); n++) {
			appendLExpr(list, new Application(left, (LExpr)list2.get(n)));
		}
		return list;
	}

	/**
	 * Υ֥ȤChurchʬʤп֤ͤ.
	 * Ǥʤ IllegalStateException 򥹥.
	 */
	protected int getChurchNumeral(String succ, String zero) {
		if (succ == null || zero == null)
			throw new IllegalStateException();
		int number = 0;
		LExpr e = this;
		for ( ; e.getFunction() != null; e = ((Application)e).right) {
			LExpr left = ((Application)e).left;
			if (!succ.equals(left.variableName()))
				throw new IllegalStateException();
			number++;
		}
		if (!zero.equals(e.variableName()))
			throw new IllegalStateException();
		return number;
	}

	/**
	 * ǤʷʿŪɽʸ֤.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		String ls = left.toAbbrevString(uselambda);
		String rs = right.toAbbrevString(uselambda);
		String s1 = mustParenthesizeLeft() ? parenthesize(ls) : ls;
		String s2 = mustParenthesizeRight() ? parenthesize(rs) : rs;
		return s1 + s2;
	}

	/**
	 * ʷʿŪɽʸ֤.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		String ls = left.toMathString(uselambda);
		String rs = right.toMathString(uselambda);
		String s1 = mustParenthesizeLeft() ? parenthesize(ls) : ls;
		String s2 = mustParenthesizeRight() ? parenthesize(rs) : rs;
		return s1 + s2;
	}

	/**
	 * ĹʿŪɽʸ֤.
	 *  x.(y.(z.((xy)z)))
	 */
	protected String toProperString(boolean uselambda) {
		String ls = left.toProperString(uselambda);
		String rs = right.toProperString(uselambda);
		return parenthesize(ls) + parenthesize(rs);
	}

	/**
	 * Υ֥ȤδʷʿŪɽˤ1(¦)˳̤ɬ
	 * ʤtrue֤.
	 *     left     right   toMathString()
	 *   -----------------------------------
	 *     x.y      M       (x.y)M
	 *     xyx.y    M       (xyx.y)M
	 */
	private boolean mustParenthesizeLeft() {
		if (left.getBody() != null)
			return true;
		if (left.getFunction() != null)
			if (((Application)left).right.getBody() != null)
				return true;
		return false;
	}

	/**
	 * Υ֥ȤδʷʿŪɽˤ2(¦)˳̤ɬ
	 * ʤtrue֤.
	 *     left   right   toMathString()
	 *   ---------------------------------
	 *      xy    zx.y    xy(zx.y)
	 */
	private boolean mustParenthesizeRight() {
		return right.getFunction() != null;
	}

	/**
	 * ͳѿ«ѿ̤٤Ƥѿ򽸤.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void gatherVars(Set set) {
		left.gatherVars(set);
		right.gatherVars(set);
	}

	/**
	 * бɽ򻲾Ȥѿ֤̾.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void replaceVars(Map map) {
		left.replaceVars(map);
		right.replaceVars(map);
	}
}
