package mypkg.lambda;

/**
 * -redexι
 *
 * (x.M)N ηΥ -redex ȸƤ. Υ饹Ϥ -redex
 * ιǤɽ.
 * Υ饹Υ֥Ȥϥĥ꡼ΥΡɤȤʤ뤳ȤꤷƤʤ.
 * ĥ꡼ΥΡɤȤʤ륯饹 Variable, Abstraction, Application Ǥ.
 * Υ饹 -redex 黻Ȥη̤Υȥ졼Ϥ
 * ŪΤѤ.
 * Ȥ
 *     z(z$07)[$07:=$01]
 * Τ褦ʥȥ졼Ϥѿ֤(LExpr.reshape())
 *     ($07.z(z$07))$01
 * Ѵ LExpr.reshape() ¹Ԥ
 *     (y.z(zy))x
 * Ȥʤ. Υ鼡η̤.
 *     (z(zy))[y:=x]
 * ĤޤꤳΥ饹 -redex δؿ, , °ޤȤƵ
 * .
 */
public class BetaRedex extends LExpr {

	private LExpr body;       // M -- (x.M)N
	private String param;     // x -- (x.M)N
	private LExpr arg;        // N -- (x.M)N

	/**
	 * 󥹥ȥ饯
	 */
	public BetaRedex(LExpr body, String param, LExpr arg) {
		this.body = body;
		this.param = param;
		this.arg = arg;
	}

	/**
	 * Υ֥ȤΥԡ֤.
	 */
	public Object clone() {
		BetaRedex newexpr = null;
		try {
			newexpr = (BetaRedex)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.body = (LExpr)this.body.clone();
		newexpr.param = this.param;
		newexpr.arg = (LExpr)this.arg.clone();
		return newexpr;
	}

	/**
	 * ؿΤΥ֤.
	 */
	public LExpr getBodyOfRedex() { return body; }

	/**
	 * ֤̾.
	 */
	public String getParamOfRedex() { return param; }

	/**
	 * °Υ֤.
	 */
	public LExpr getArgOfRedex() { return arg; }

	/**
	 * Х饤
	 * Ѵդ줿ѿ֤, ؿ, , °
	 * ֤Ʊ˹Ԥɬפ. ä, Ǥϰö
	 * ȤΩƤƥѥ饹 reshape() ¹Ԥ, Ƥ -redex
	 * .
	 */
	public LExpr reshape() {
		LExpr abs = LExpr.getInstance(param, body);  // x.M
		LExpr app = LExpr.getInstance(abs, arg);     // (x.M)N
		LExpr newapp = app.reshape();
		LExpr newabs = newapp.getFunction();
		return LExpr.getInstance(
			newabs.getBody(), newabs.parameterName(), newapp.getArgument()
		);
	}

	/**
	 * ǤʷʿŪɽʸ֤.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		String bs = body.toAbbrevString(uselambda);
		String as = arg.toAbbrevString(uselambda);
		return substString(bs, param, as);
	}

	/**
	 * ʷʿŪɽʸ֤.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		String bs = body.toMathString(uselambda);
		String as = arg.toMathString(uselambda);
		return substString(bs, param, as);
	}

	/**
	 * ĹʿŪɽʸ֤.
	 *  (x.(y.(z.((xy)z))))[x:=N]
	 */
	protected String toProperString(boolean uselambda) {
		String bs = body.toProperString(uselambda);
		String as = arg.toProperString(uselambda);
		return substString(bs, param, as);
	}

	private String substString(String bs, String param, String as) {
		StringBuffer sb = new StringBuffer(parenthesize(bs));
		sb.append("[").append(param).append(":=").append(as).append("]");
		return sb.toString();
	}
}
