package mypkg.lambda;

import java.io.PrintWriter;
import java.io.IOException;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.Map;
import java.util.Iterator;
import java.lang.reflect.Constructor;

/**
 * ׻󥿥եμ
 *
 * ׻饹LambdaCalculusѾ
 *   ʸ󤫤ؤѴ
 *   η׻̤ν
 *   η׻
 *   ޥδ
 *   ֤δ
 *       ξ -- ׻ߤʤ礳βǤڤ.
 *       νϷ -- xy.xyz | x.y.xyz | x.(y.((xy)z))
 *       ׻̤ޥ᤹ɤ
 * ʬô.
 * Υ饹󶡤륤󥿥ե LExprHandler ϥ(LExpr)
 * μۤȤɬפȤ˥׻ԤȤŪȤ߷פƤ.
 *
 * ƥץѥƥ
 * ~~~~~~~~~~~~~~~~~~
 * ξͤν lambdacalc.maxsteps
 *   ׻ߤʤȤȽˡȤƴå.
 *   ͤϤνͤȤƻȤ.
 *   ǥե: 10000
 * Ϥ˥ޥ̾ȤʤȤꤹץѥƥ lambdacalc.nomacro
 *   ǽ: true ޤ false (̤ false)
 *   ǥե: false
 */
public class ExpressionHandler implements LExprHandler {

	// Υ饹¸ΤϲΥ饹Ǥ.
	// mypkg.lambda.LExprHandler   ׻󥿥ե
	// mypkg.lambda.LExprFactory   󥿥ե
	// mypkg.lambda.LExprConverter ޥǽɲä륤󥿥ե
	// mypkg.lambda.LExpr          ɽݥ饹
	// mypkg.lambda.ResultValue    ׻η׻
	// mypkg.lambda.TraceInfo      ȥ졼Ͼδ
	//
	// ϤΥ饹ǤŪ˰ƤΤǥΥ֥饹
	// (ѿݡؿŬ)ȤŪʰ¸Ϥʤ. ¤κݤ.
	//
	// (LExpr)ϥ׻ǽäƤΤ
	//     LExpr value = expr.reduce();
	// Τ褦ʵҤǽǤ.
	// Υ饹ѼԤϤΥ饹򥪥ڥ졼, LExpr򥪥ڥ
	// Τ褦˹ͤ
	//     LExpr value = handler.convert(expr);
	// ȵҤʤФʤʤ. LExpr˴ؤμϤۤȤɬפʤ.

	private LExprFactory factory;
	private LExprConverter converter;

	private int maxSteps;         // ξ
	private String format;        // νϷ
	private boolean useMacro;     // ׻̤Υ˥ޥ̾Ȥ.

	private final String macroStart;    // ޥȤγϵ
	private final String macroEnd;      // ޥȤνλ

	private final String False;
	private final String True;
	private final String Zero;
	private final String Number;

	private static final String PREFIX = LExpr.PREFIX;

	private static final String FORMATLIST[] = {
		// ɲäȤLISPΣͼӼʤ
		LExpr.ABBREVFORMAT, LExpr.MATHFORMAT, LExpr.PROPERFORMAT,
	};
	private static final String FORMATDESC[] = {
		LExpr.ABBREVFORMAT + " ǤʷʿŪɽ   [] xy.xyz",
		LExpr.MATHFORMAT + "   ʷ̾οŪɽ [] x.y.xyz",
		LExpr.PROPERFORMAT + " ̤¿Ūɽ   [] x.(y.((xy)z))",
	};

	private static final String
		INVALID = "invalid syntax",
		NULLNAME = "macro name is null",
		EMPTYNAME = "macro name is empty",
		AMBIGUOUS = "ambiguous arg",
		INVALARG = "invalid arg",
		INVALNAME = "invalid macro name";

	/**
	 * 󥹥ȥ饯
	 *
	 * @param mstart ޥȤγϵ
	 * @param mend ޥȤνλ
	 * @param w  ֥ȺΥȥ졼 (nullʤХȥ졼ʤ)
	 */
	public ExpressionHandler(String mstart, String mend, PrintWriter w)
			throws IOException {

		macroStart = mstart;
		macroEnd = mend;
		False = macroStart + "false" + macroEnd;
		True = macroStart + "true" + macroEnd;
		Zero = macroStart + "0" + macroEnd;
		Number = ".*" + macroStart + "[0-9]+" + macroEnd + ".*";

		converter = createConverter(macroStart, macroEnd);
		factory = createFactory(converter, w);

		String s = System.getProperty(PREFIX + "maxsteps");
		maxSteps = (s != null && s.length() > 0) ? Integer.parseInt(s) : 1000;
		useMacro = !"true".equals(System.getProperty(PREFIX + "nomacro"));
		initFormat(System.getProperty(LExpr.DEFFORMATKEY, LExpr.ABBREVFORMAT));
	}

	/**
	 * ʸLExprΥѴ.
	 *
	 * @param s Ѵоݤʸ
	 * @return   (LExpr)
	 */
	public LExpr createLExpr(String s) {
		return toLExpr(s);
	}

	/**
	 * LExprΥϤ.
	 * դ.
	 * ̤ޥ֤꤬̾äƤϤ줿
	 *   ޥȤƤʤХޥ֤̾ʤ.
	 * false  0 ϤޤäƱʤΤϤ줿
	 *   Ǥ򤹤.
	 *
	 * @param out     
	 * @param expr    оݤΥ
	 * @param s       Ϥ줿 (ϻξ򻲾Ȥ뤿)
	 * @param verbose ȥ졼Ϥ.
	 */
	public void print(PrintWriter out, LExpr expr, String s, boolean verbose) {
		if (verbose)
			printTraceInfo(s, out);
		printLExpr(out, expr, s);
	}

	/**
	 * Υ.
	 *
	 * δ򷫤֤.
	 * ̤ʣ, ǽη̤򷫤֤׻.
	 * ǽǤз̤ϰդ˷ޤ.
	 *  [׻]
	 *     ((a.b)c)((x.y)z) --step--> [b((x.y)z); ((a.b)c)y]
	 *     b((x.y)z) --step--> [by]
	 * #################################################################
	 * ĤʤкǤ⳰¦ΥǥåΤǺǤ⺸¦
	 * ΤΤ󤹤뤳Ȥɬ.
	 * Ȥ
	 *     (x.y)((x.xx)(x.xx)))
	 *  (x.xx)(x.xx) δ˹Ԥ̵¤δ³ (x.y)M
	 * ȸУδ y Ȥʤ.
	 * #################################################################
	 *
	 * ׻ߤʤnullη׻̤ResultValue֤.
	 * ׻ߤʤȤȽϰǻꤵ줿ξ¤
	 * ĶȤ.
	 *
	 * @param expr ׻оݤΥ
	 * @param verbose trueʤХΥȥ졼Ͽ
	 * @return  Υ, , ׻֤ݻ륪֥
	 *          ׻ߤʤϥnullΥ֥
	 *          Υnullʤnull
	 */
	public ResultValue normalize(LExpr expr, boolean verbose) {
		if (expr == null)
			return null;
		// ȥ졼ν
		TraceInfo.getInstance().init(verbose);
		// ˡѿ̾ǽν
		LExpr.init();
		// Ƚ׻֤¬.
		int nsteps = 0;
		long t = System.currentTimeMillis();
		for ( ; ; nsteps++) {
			if (nsteps >= maxSteps) {
				// [] (x.xx)(x.xx)
				expr = null;
				break;
			}
			LExpr newexpr = reduce(expr);
			if (newexpr == null)
				break;
			expr = newexpr;
		}
		long time = System.currentTimeMillis() - t;
		if (expr != null)
			expr = expr.reshape();
		return new ResultValue(expr, nsteps, time);
	}

	/**
	 * Τ٤ƤΣƥå״̤֤.
	 * ƥå״η̤ʣΤ, Υ᥽åɤLExpr[]
	 * ֤ͤ.
	 *
	 * @param expr  оݤΥ
	 * @return  ƥå״󤵤줿
	 */
	public LExpr[] step(LExpr expr) {
		// ȥ졼ν (ߤλͤϥȥ졼ʤ)
		boolean verbose = false;
		TraceInfo.getInstance().init(verbose);
		LExpr array[] = reduceAll(expr);
		for (int n = 0; n < array.length; n++)
			array[n] = array[n].reshape();
		return array;
	}

	/**
	 * Ϳ줿򣱥ƥå׺Ǻ󤷤֤.
	 * step()Ȥΰ㤤ϺǺ׻뤳ȤǤ.
	 * normalize()ϤΥ᥽åɤãޤǷ֤̤֤.
	 *
	 * @param expr оݤΥ
	 * @param verbose ȥ졼
	 * @return Ǻ󤵤줿 (Ǥʤnull֤.)
	 */
	public LExpr convert(LExpr expr) {
		// ȥ졼ν (ߤλͤϥȥ졼ʤ)
		boolean verbose = false;
		TraceInfo.getInstance().init(verbose);
		LExpr newexpr = reduce(expr);
		return (newexpr != null) ? newexpr.reshape() : null;
	}

	/**
	 * M[x:=N] ޤ [N/x]M ηʸᤷ黻η̤֤.
	 *
	 * @param s Ѵоݤʸ ("M[x:=N]" ޤ "[N/x]M")
	 * @return  黻̤Υ
	 */
	public LExpr substitute(String s) {
		if (s.length() <= 0)
			return null;
		try {
			LExpr redex = factory.parseSubstitution(s);
			LExpr body = redex.getBodyOfRedex();
			String param = redex.getParamOfRedex();
			LExpr arg = redex.getArgOfRedex();
			return body.substitute(param, arg).reshape();
		} catch (Exception e) {
			throw new IllegalArgumentException(INVALID + arg(s));
		}
	}

	/**
	 * Ϳ줿μͳѿν֤.
	 *
	 * @param expr ĴоݤΥ
	 * @return  μͳѿν
	 */
	public Set freeVariables(LExpr expr) {
		return expr.freeVariables();
	}

	/**
	 * ޥ.
	 *
	 * @param name  ޥ̾
	 * @param value 
	 */
	public void defineMacro(String name, String value) {
		define(name, value);
		// ޥΥǥ󥰤λȤΤ.
		converter.initMacros();
	}

	/**
	 * Ϳ줿бɽΥޥ.
	 *
	 * @param map ޥ̾ͤбɽ
	 */
	public void defineMacros(Map map) {
		for (Iterator i = map.keySet().iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			String value = (String)map.get(name);
			define(name, value);
		}
		// ޥΥǥ󥰤λȤΤ.
		converter.initMacros();
	}

	/**
	 * ޥΰϤ.
	 *
	 * @param out 
	 * @param msg ˽Ϥ (nullʤнϤʤ)
	 */
	public void printMacros(PrintWriter out, String msg) {
		converter.printMacros(out, msg);
	}

	/**
	 * ξͤꤹ.
	 *
	 * @param maxSteps ξ
	 */
	public void setMaxSteps(int maxSteps) { this.maxSteps = maxSteps; }

	/**
	 * ꤵƤξ֤ͤ.
	 *
	 * @return ξ
	 */
	public int getMaxSteps() { return maxSteps; }

	/**
	 * νϷꤹ.
	 * FORMATLIST줿ʸʬŪ˰פ뤳.
	 *
	 * @param s  νϷ̾ (ʬ)
	 */
	public void setFormat(String s) {
		if (s != null && s.length() > 0) {
			List list = new ArrayList();
			for (int n = 0; n < FORMATLIST.length; n++) {
				String fmt = FORMATLIST[n];
				if (fmt.startsWith(s))
					list.add(fmt);
			}
			if (list.size() == 1) {
				initFormat((String)list.get(0));
				return;
			}
			if (list.size() >= 2)
				throw new IllegalArgumentException(AMBIGUOUS + arg(s));
		}
		throw new IllegalArgumentException(INVALARG + arg(s));
	}

	/**
	 * νϷѥ᡼ʸ֤.
	 *
	 * @param indent ʸ֤륤ǥʸ
	 */
	public String getFormatCaption(String indent) {
		String eol = System.getProperty("line.separator");
		StringBuffer sb = new StringBuffer();
		for (int n = 0; n < FORMATDESC.length; n++) {
			sb.append(indent).append(FORMATDESC[n]);
			if (n < FORMATDESC.length-1)
				sb.append(eol);
		}
		return sb.toString();
	}

	/**
	 * νϤޥ̾Ѵ뤫ɤꤹ.
	 *
	 * @param value  trueʤнϤޥ̾Ѵ
	 */
	public void setReshape(boolean value) { useMacro = value; }

	/**
	 * ()Ѵ뤫ɤ椹.
	 *
	 * @param suppress trueʤЦѴ
	 */
	public void suppressEtaConversion(boolean suppress) {
		LExpr.suppressEtaConversion(suppress);
	}

	/*--------------------------------------------------------------------*/

	/**
	 * Σƥå׺Ǻ -- Ѵ
	 *
	 * Υ᥽åɤϼ¼ŪʦѴreduce()ƤӽФ̵̤ʥȥ졼
	 * 뵡ǽɲä.
	 * Ƚreduce()μ¹Է̤ null ɤǷޤ.
	 * äƥȥ졼ϤƤˤ줿κǸ
	 * ȥ졼̵̤Ǥ. ̵̤ʤῷTraceInfoȤ.
	 * Υ᥽åɤϤǤʤХȥ졼Ϥʤ.
	 *
	 * @param expr  оݤΥ
	 * @return  ƥå״̤Υꥹ (Ǥʤnull)
	 */
	private LExpr reduce(LExpr expr) {
		TraceInfo trinf = TraceInfo.getInstance();
		if (trinf.isVerbose()) {
			trinf = trinf.push();
			if (expr.variableName() == null)
				trinf.appendTarget(expr, 0, "");
		}
		LExpr newexpr = expr.reduce();
		if (trinf.isVerbose()) {
			trinf.appendResult(newexpr, 0, "");
			trinf.pop(newexpr != null);
		}
		return newexpr;
	}

	/**
	 * Σƥå״ -- Ѵ
	 *
	 * Υ᥽åɤϼ¼ŪʦѴreduceAll()ƤӽФ̵̤ʥȥ졼
	 * 뵡ǽɲä.
	 * ȽreduceAll()μ¹Է̤󤫤ɤǷޤ.
	 * äƥȥ졼ϤƤˤ줿κǸ
	 * ȥ졼̵̤Ǥ. ̵̤ʤῷTraceInfoȤ.
	 * Υ᥽åɤϤǤʤХȥ졼Ϥʤ.
	 *
	 * @param expr  оݤΥ
	 * @return  ƥå״̤
	 */
	private LExpr[] reduceAll(LExpr expr) {
		TraceInfo trinf = TraceInfo.getInstance();
		if (trinf.isVerbose()) {
			trinf = trinf.push();
			if (expr.variableName() == null)
				trinf.appendTarget(expr, 0, "");
		}
		LExpr array[] = expr.reduceAll();
		if (trinf.isVerbose()) {
			trinf.appendArray(array, 0, "");
			trinf.pop(array.length > 0);
		}
		return array;
	}

	/**
	 * ʸLExprΥѴ.
	 */
	private LExpr toLExpr(String s) {
		LExpr expr = null;
		try {
			expr = (s.indexOf('[') >= 0)
				? factory.parseSubstitution(s) : factory.create(s);
		} catch (Exception ex) {
			throw new IllegalArgumentException(ex.getMessage() + arg(s));
		}
		return expr;
	}

	/**
	 * ׻̤ΥϤ.
	 */
	private void printLExpr(PrintWriter out, LExpr expr, String s) {
		boolean uselambda = usingLambda(s);
		String sval = (useMacro && s.indexOf(macroStart) >= 0)
			? converter.reshape(expr, uselambda)
			: expr.getString(format, uselambda);
		if (sval.indexOf(False) >= 0) {
			if (s.matches(Number))
				sval = sval.replaceAll(False, Zero);
		} else if (sval.indexOf(Zero) >= 0) {
			if (s.indexOf(True) >= 0 || s.indexOf(False) >= 0)
				sval = sval.replaceAll(Zero, False);
		}
		out.println(sval);
	}

	/**
	 * ȥ졼̤Ϥ.
	 *
	 * @param s Ϥ줿
	 * @param out ȥ졼
	 */
	private void printTraceInfo(String s, PrintWriter out) {
		boolean uselambda = usingLambda(s);
		boolean convert = useMacro && s.indexOf(macroStart) >= 0;
		TraceInfo trinf = TraceInfo.getInstance();
		List list = trinf.getExprList();
		String array[] = new String[list.size()];
		for (int n = 0; n < list.size(); n++) {
			LExpr expr = ((LExpr)list.get(n)).reshape();
			array[n] = convert ? converter.reshape(expr, uselambda)
					: expr.getString(format, uselambda);
		}
		trinf.print(out, array);
		out.flush();
	}

	/**
	 * νϷꤹ.
	 */
	private void initFormat(String s) {
		format = s;
		converter.setFormat(s);
	}

	/**
	 * ХååǤϤʤˤȤäƽϤtrue֤.
	 */
	private boolean usingLambda(String s) {
		return s.indexOf('') >= 0;
	}

	/*--------------------------------------------------------------------*/

	/**
	 * ޥ.
	 */
	private void define(String name, String value) {
		if (name == null)
			throw new IllegalArgumentException(NULLNAME);
		name = name.trim();
		if (name.length() <= 0)
			throw new IllegalArgumentException(EMPTYNAME);
		if (!isIdStart(name.charAt(0)))
			throw new IllegalArgumentException(INVALNAME + arg(name));
		for (int n = 1; n < name.length(); n++)
			if (!isIdPart(name.charAt(n)))
				throw new IllegalArgumentException(INVALNAME + arg(name));
		String xvalue = converter.expandMacros(value);
		LExpr expr = toLExpr(xvalue);  // ʸˡåͤ.
		converter.appendMacro(name, value, expr);
	}

	/**
	 * ޥ̾ƬʸȤƲǽʤtrue֤.
	 * ͤȤ.
	 */
	private boolean isIdStart(int c) {
		return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z'
			|| '0' <= c && c <= '9';
	}

	/**
	 * ޥ̾ΣʸܰʹߤȤƲǽʤtrue֤.
	 */
	private boolean isIdPart(int c) {
		return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z'
			|| '0' <= c && c <= '9';
	}

	/*--------------------------------------------------------------------*/

	/**
	 * LExprFactory֥Ȥ.
	 * Ϥ LExprConverter ϥޥŸǽԤƤ.
	 * ⤷ null ϤȥޥŸʤ.
	 *
	 * @param converter ޥŸ֥ (nullʤХޥŸʤ)
	 * @param out ֥ȺΥȥ졼 (nullʤХȥ졼ʤ)
	 */
	private LExprFactory createFactory(LExprConverter converter,
			PrintWriter out) {
		String key = LExprFactory.class.getName() + ".class";
		String className = System.getProperty(key);
		if (className != null && className.length() > 0) {
			try {
				Class c = Class.forName(className);
				Constructor con = c.getConstructor(new Class[]{
					LExprConverter.class, PrintWriter.class
				});
				return (LExprFactory)con.newInstance(new Object[]{
					converter, out
				});
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		throw new IllegalStateException("check env");
	}

	/**
	 * LExprConverter֥Ȥ.
	 */
	private LExprConverter createConverter(String macroStart, String macroEnd) {
		String key = LExprConverter.class.getName() + ".class";
		String className = System.getProperty(key);
		if (className != null && className.length() > 0) {
			try {
				Class c = Class.forName(className);
				Constructor con = c.getConstructor(new Class[]{
					String.class, String.class
				});
				return (LExprConverter)con.newInstance(new Object[]{
					macroStart, macroEnd
				});
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		throw new IllegalStateException("check env");
	}

	/*--------------------------------------------------------------------*/

	/**
	 * 顼å˾ɲä.
	 */
	private String arg(String s) { return ": \"" + s + "\""; }
}
