package mypkg.lambda;

import java.util.Map;
import java.util.LinkedHashMap;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Collections;
import java.io.PrintWriter;

/**
 * ޥδ
 *
 * ޥǽɲä륤󥿥ե LExprConverter μ饹Ǥ.
 *
 * Υ饹ϼΤȤ.
 * Ϥ줿ʸ󤫤ޥȤ򸫤ĤФޥŸ줿
 *   ʸѴ.
 * ׻̤Υޥͤ򸫤ĤФޥִ̾뤳
 *   ˤ꼰򸫤䤹.
 */
public class LExprShaper implements LExprConverter {

	private Map symtab;          // ޥ̾ȥޥ(ʸ)бɽ
	private Map exprtab;         // ޥ̾ȥޥ(LExpr)бɽ
	private List infoList;       // List<MacroInfo>

	private String format;       // νϷ

	private final String macroStart;   // ޥȤγϵ
	private final String macroEnd;     // ޥȤνλ

	private static final String Lambda = "\\";
	private static final String Succ = "s";
	private static final String Zero = "z";

	/**
	 * 󥹥ȥ饯
	 *
	 * @param macroStart ޥȤγϵ
	 * @param macroEnd ޥȤνλ
	 */
	public LExprShaper(String macroStart, String macroEnd) {
		this.macroStart = macroStart;
		this.macroEnd = macroEnd;
		this.symtab = new LinkedHashMap();
		this.exprtab = new HashMap();
		setFormat(System.getProperty(LExpr.DEFFORMATKEY, LExpr.ABBREVFORMAT));
	}

	/**
	 * νϷꤹ.
	 *
	 * @param s νϷ (LExpr.getString()Ϥ)
	 */
	public void setFormat(String s) {
		format = s;
	}

	/**
	 * ޥ˴ؤ.
	 * ޥͤ˥ޥȤޤޤƤǽꤷƤ.
	 */
	public void initMacros() {
		infoList = new ArrayList();
		for (Iterator i = symtab.keySet().iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			String value = (String)symtab.get(name);
			LExpr expr = (LExpr)exprtab.get(name);
			infoList.add(new MacroInfo(name, expand(value), expr));
		}
		Collections.sort(infoList);  // Ĺޥͥ褵.
	}

	/**
	 * ޥɲý
	 *
	 * @param name  ޥ̾
	 * @param value ޥ
	 * @param expr  ޥͤΥ
	 */
	public void appendMacro(String name, String value, LExpr expr) {
		symtab.put(name, value);
		exprtab.put(name, expr);
	}

	/**
	 * ޥŸ
	 *
	 * @param s ޥȤޤ
	 * @return ޥŸ줿
	 */
	public String expandMacros(String s) {
		return expand(s);
	}

	/**
	 * ޥΰϤ.
	 *
	 * @param out 
	 * @param msg ʸ (nullʤнϤʤ)
	 */
	public void printMacros(PrintWriter out, String msg) {
		if (symtab.size() <= 0)
			return;
		out.println();
		if (msg != null && msg.length() > 0)
			out.println(msg);
		for (Iterator i = symtab.keySet().iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			String value = (String)symtab.get(name);
			out.println("\t" + name + "\t" + value);
		}
		for (int number = 0; number <= 5; number++) {
			String name = String.valueOf(number);
			String value = numberMacro(number);
			out.println("\t" + name + "\t" + value);
		}
		out.println("\t  ");
		StringBuffer sb = new StringBuffer();
		sb.append(Lambda).append(Succ).append(Zero).append(".");
		sb.append(Succ).append("(").append(Succ);
		sb.append("((").append(Succ).append(Zero).append(")))");
		out.println("\tn\t" + sb.toString());
		out.println("\t  ");
		out.println();
	}

	/**
	 * LExprΥǤޥ̾ȤäʸѴ.
	 *
	 * @param expr 
	 * @param uselambda ˦ˤȤtrue, \ Ȥfalse
	 * @return Ѵ줿ʸΥ
	 */
	public String reshape(LExpr expr, boolean uselambda) {
		LExpr newexpr = convert(expr);
		return newexpr.getString(format, uselambda);
	}

	/**
	 * ޥ̾ؤѴ
	 * Ūάϥޥ̾ȰפΡɤ饹MacroΥ֥
	 * ֤ʤͿ줿ΥԡȤ.
	 */
	private LExpr convert(LExpr expr) {
		String mname = searchMacro(expr);
		if (mname != null)
			return new Macro(mname);
		if (expr.variableName() != null)
			return (LExpr)expr.clone();
		if (expr.parameterName() != null) {
			String param = expr.parameterName();
			LExpr e = expr.getBody();
			String macro = searchMacro(e);
			LExpr newexpr = (macro != null) ? new Macro(macro) : convert(e);
			return LExpr.getInstance(param, newexpr);
		}
		if (expr.getBodyOfRedex() != null) {
			LExpr body = convert(expr.getBodyOfRedex());
			String param = expr.getParamOfRedex();
			LExpr arg = convert(expr.getArgOfRedex());
			return LExpr.getInstance(body, param, arg);
		}
		LExpr left = expr.getFunction();
		String lmacro = searchMacro(left);
		LExpr newleft = (lmacro != null) ? new Macro(lmacro) : convert(left);
		LExpr right = expr.getArgument();
		String rmacro = searchMacro(right);
		LExpr newright = (rmacro != null) ? new Macro(rmacro) : convert(right);
		return LExpr.getInstance(newleft, newright);
	}

	/**
	 * ޥŸ.
	 */
	private String expand(String s) {
		int start = s.indexOf(macroStart);
		if (start < 0)
			return s;
		int end = s.indexOf(macroEnd, start + macroStart.length());
		if (end < 0) {
			String msg = "\"" + macroEnd + "\" expected";
			throw new IllegalArgumentException(msg);
		}
		String name = s.substring(start + macroStart.length(), end);
		String value = (String)symtab.get(name);
		if (value == null) {
			if ((value = numberMacro(name)) == null) {
				String msg = "undefined macro: \"" + name + "\"";
				throw new IllegalArgumentException(msg);
			}
		}
		StringBuffer sb = new StringBuffer();
		sb.append(s.substring(0, start)).append("(").append(value).append(")");
		sb.append(s.substring(end + macroEnd.length()));
		return expand(sb.toString());
	}

	/**
	 * ΥޥȰפʤХޥ֤̾.
	 */
	private String searchMacro(LExpr expr) {
		for (int n = 0; n < infoList.size(); n++) {
			MacroInfo info = (MacroInfo)infoList.get(n);
			if (info.match(expr))
				return info.getName();
		}
		int number = getNumber(expr);
		if (number >= 0)
			return String.valueOf(number);
		return null;
	}

	/**
	 * ʸ󤬿ͤʤбʸ֤.
	 *     0 = sz.z
	 *     1 = sz.sz
	 *     2 = sz.s(sz)
	 *     3 = sz.s(s(sz))
	 */
	private String numberMacro(String s) {
		int number = 0;
		try {
			number = Integer.parseInt(s);
		} catch (NumberFormatException e) {
			return null;  // ͤǤϤʤ.
		}
		return numberMacro(number);
	}

	/**
	 * οͤбʸ֤.
	 */
	private String numberMacro(int number) {
		StringBuffer sb = new StringBuffer();
		sb.append(Lambda).append(Succ).append(Zero).append(".");
		for (int n = 0; n < number; n++) {
			if (n >= 1)
				sb.append("(");
			sb.append(Succ);
		}
		sb.append(Zero);
		for (int n = 1; n < number; n++)
			sb.append(")");
		return sb.toString();
	}

	/**
	 * Υ sz.s(s((sz))) ʤб֤ͤ.
	 *     0 = sz.z
	 *     1 = sz.sz
	 *     2 = sz.s(sz)
	 *     3 = sz.s(s(sz))
	 */
	private int getNumber(LExpr expr) {
		try {
			return expr.getChurchNumeral(null, null);
		} catch (IllegalStateException e) {
		}
		return -1;
	}

	/**
	 * ޥ˴ؤ
	 */
	private class MacroInfo implements Comparable {
		private String name;    // ޥ̾
		private String value;   // ޥ (String)
		private LExpr expr;     // ޥ (LExpr)
		MacroInfo(String name, String value, LExpr expr) {
			this.name = name;
			this.value = value;
			this.expr = expr;
		}
		boolean match(LExpr e) {
			return expr.isAlphaEquivalent(e);
		}
		String getName() { return name; }
		public int compareTo(Object obj) {
			MacroInfo arg = (MacroInfo)obj;
			// Ĺޥͥ褵.
			return arg.value.length() - this.value.length();
		}
	}

	/**
	 * ޥ̾ȰפΡɤ֤LExprΥ֥饹
	 */
	private class Macro extends LExpr {
		private String name;
		Macro(String name) {
			this.name = name;
		}
		public Object clone() {
			Macro newexpr = null;
			try {
				newexpr = (Macro)super.clone();
			} catch (Exception e) {
				// assert false;
			}
			newexpr.name = this.name;
			return newexpr;
		}
		protected String toAbbrevString(boolean uselambda) {
			return macroStart + name + macroEnd;
		}
		protected String toMathString(boolean uselambda) {
			return macroStart + name + macroEnd;
		}
		protected String toProperString(boolean uselambda) {
			return macroStart + name + macroEnd;
		}
	}
}
