package mypkg.lambda;

import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.PrintWriter;

/**
 * ʸ󤫤ؤѴ
 *
 * ʸ󤫤ؤѴ󥿥ե LExprFactory μ饹Ǥ.
 *
 * Ūɽ줿ʸΥ֥ȤѴ.
 * ŪɽȤ
 *     x | x.e | e1e2 | 
 * Τ褦ʸ̣.
 *
 * ѿ̾ζڤβɬפ뤿
 *     ѿ : [a-zA-Z][0-9]*
 * Ȥ.
 *
 * οŪɽˤĤƤϲδ˽.
 *
 *                             
 *   ------------------------------------------------------------------
 *     x.y.e  x.(y.e)  ¿ѿؿŪ xy.e Ƚ񤤤ƤƱ
 *     x.e1e2   x.(e1e2)   ؿŬѤϥݤ̤ͥ⤤
 *     e1e2e3     (e1e2)e3     ؿŬѤϺ
 */
public class MathLExprFactory implements LExprFactory {

	private LExprConverter converter;  // ޥŸ
	private PrintWriter out;           // ȥ졼ν

	private static final String
		INVAL_CHAR = "invalid char",
		INVAL_ABS = "invalid abstraction",
		WRONG = "invalid syntax",
		EXP_RPAREN = "invalid syntax -- \")\" expected",
		UNEXP_EOF = "unexpected EOF";

	/**
	 * 󥹥ȥ饯
	 *
	 * @param converter ޥŸѥ֥ (nullʤХޥŸ)
	 * @param out ȥ졼ν (nullʤХȥ졼ʤ)
	 */
	public MathLExprFactory(LExprConverter converter, PrintWriter out) {
		this.converter = converter;
		this.out = out;
	}

	/**
	 * Ϳ줿ʸ󤫤(LExpr).
	 *
	 * @param s Ѵоݤʸ
	 * @return 줿
	 */
	public LExpr create(String s) {
		if (s == null || s.length() <= 0)
			return null;  // empty
		return createLExpr(s, out);
	}

	/**
	 * M[x:=N] ޤ [N/x]M ηʸᤷƥ.
	 * ֤Τ黻̤ΥǤϤʤȤ.
	 *
	 * @param s Ѵоݤʸ
	 * @return 줿 (-redexɽ)
	 */
	public LExpr parseSubstitution(String s) {
		String ms = null, ns = null, param = null;
		if (s != null && s.length() > 0) {        // M[x:=N]
			if (s.charAt(s.length()-1) == ']') {
				int p1 = s.indexOf('[');
				if (p1 >= 0) {
					int p2 = s.indexOf(":=");
					if (p2 >= 0) {
						ms = s.substring(0, p1).trim();
						param = s.substring(p1+1, p2).trim();
						ns = s.substring(p2+2, s.length()-1).trim();
					}
				}
			} else if (s.charAt(0) == '[') {      // [N/x]M
				int p1 = s.indexOf('/');
				if (p1 >= 0) {
					int p2 = s.indexOf(']');
					if (p2 >= 0) {
						ns = s.substring(1, p1).trim();
						param = s.substring(p1+1, p2).trim();
						ms = s.substring(p2+1).trim();
					}
				}
			}
		}
		if (ms == null || ns == null || param == null)
			throw new IllegalArgumentException();
		LExpr body = createLExpr(ms, out);
		LExpr arg = createLExpr(ns, out);
		return LExpr.getInstance(body, param, arg);
	}

	/**
	 * Ϳ줿ʸ󤫤(LExpr).
	 *
	 * @param s Ѵоݤʸ
	 * @return 줿 (Υ.)
	 */
	private LExpr createLExpr(String s, PrintWriter out) {
		if (converter != null)
			s = converter.expandMacros(s);
		Tokenizer t = new Tokenizer(s, out);
		LExpr expr = readLExpr(t);
		String token = t.getToken();
		if (token != null)
			invalid(WRONG + ": " + token);
		return expr;
	}

	/*------------------------------------------------------------------*/
	// ʸ

	/**
	 * ֥Ȥ֤.
	 *
	 * @return  (ȡ󤬤ʤnull.)
	 */
	private LExpr readLExpr(Tokenizer t) {
		LExpr expr = null;
		for (String token = null; (token = t.getToken()) != null; ) {
			LExpr e = null;
			if (token.equals("(")) {
				// ̤ξϺƵƤӽФ
				if ((e = readLExpr(t)) == null)
					invalid(WRONG);
				if (!")".equals(t.getToken()))
					invalid(EXP_RPAREN);
			} else if (token.equals(")")) {
				// ̤ξ
				t.pushback(token);
				break;
			} else if (token.equals(LExpr.LAMBDA)) {
				// ȡ󤬥ξ --  x.e
				e = getAbstraction(t);
			} else if (isVarString(token)) {
				// ȡѿξ --  x, e12
				e = LExpr.getInstance(token);
			} else {
				// 嵭ʳϥ󥿥顼
				invalid(WRONG + ": " + token);
			}
			// ؿŬѤ򺸷Ū˷礹. --  (e1e2)e3
			expr = (expr == null) ? e : LExpr.getInstance(expr, e);
		}
		return expr;
	}

	/**
	 * (Abstraction)֥Ȥ֤.
	 *
	 * ɤ񤷤֤ǸƤӽФ. ¿ѿ
	 * ؿ(xy.eʤ)ξϥɤȤߤʤƸƤӽФ.
	 *
	 *  x.e
	 *    x.y.e -> x.(y.e)
	 *    xyz.e -> (x.(y.(z.e)))
	 */
	private LExpr getAbstraction(Tokenizer t) {
		String param = t.getToken();
		if (param == null)
			invalid(UNEXP_EOF);
		String token = t.getToken();
		if (!".".equals(token)) {
			if (isVarString(token)) {
				t.pushback(token);
				// ¿ѿؿ xyz.e -> (x.(y.(z.e)))
				return LExpr.getInstance(param, getAbstraction(t));
			}
			invalid(INVAL_ABS);
		}
		LExpr expr = readLExpr(t);
		if (expr == null)
			invalid(INVAL_ABS);
		return LExpr.getInstance(param, expr);
	}

	/**
	 * Υȡѿʤtrue֤.
	 */
	private boolean isVarString(String token) {
		if (token == null || token.length() <= 0)
			return false;
		return LExpr.isVariableStart(token.charAt(0));
	}

	/**
	 * ʸˡȿ㳰򥹥.
	 */
	private void invalid(String msg) {
		throw new IllegalArgumentException(msg);
	}

	/*------------------------------------------------------------------*/

	/**
	 * Ϥʬô饹
	 */
	private class Tokenizer {

		private String string;
		private int offset;
		private int length;
		private String unget_token;
		private PrintWriter trout;

		/**
		 * 󥹥ȥ饯
		 */
		Tokenizer(String s, PrintWriter out) {
			string = s;
			offset = 0;
			length = s.length();
			unget_token = null;
			trout = out;
		}

		/**
		 * ȡ֤.
		 *  [] EOF, "", "(", ")", ".", "x", "e12"
		 */
		String getToken() {
			String token = separate();
			if (trout != null)
				trout.println("#token: " + token);
			return token;
		}

		/**
		 * ȡ᤹.
		 */
		void pushback(String token) {
			if (trout != null)
				trout.println("#pushback: " + token);
			unget_token = token;
		}

		/**
		 * Ϸѿ
		 *     [a-zA-Z][0-9]*
		 * ǤʤФʤʤ. Ĥޤʸʸ˿Ϣ뤷ʸ
		 * Τߤ. ϿŪɽδʷ餵뤿Ǥ.
		 * Ū˺ѿ̾ϰۤʤȤʤ.
		 */
		private String separate() {
			if (unget_token != null) {
				String token = unget_token;
				unget_token = null;
				return token;
			}
			int c = -1;
			while ((c = getChar()) >= 0 && isBlank(c))
				;
			if (c < 0)
				return null;  // EOF
			if (c == LExpr.LAMBDA.charAt(0) || "().".indexOf(c) >= 0)
				return String.valueOf((char)c);
			if (c == '\\')
				return LExpr.LAMBDA;  // Ϥصޤ.
			if (!LExpr.isVariableStart(c))
				invalid(INVAL_CHAR + ": " + String.valueOf((char)c));
			// ѿ̾ξ
			StringBuffer sb = new StringBuffer(String.valueOf((char)c));
			while ((c = getChar()) >= 0 && Character.isDigit((char)c))
				sb.append((char)c);
			if (c >= 0)
				ungetChar(c);
			return sb.toString();
		}

		private boolean isBlank(int c) {
			return c == ' ' || c == '\t' || c == '\n' || c == '\r';
		}

		private int getChar() {
			if (offset >= length)
				return -1;
			return string.charAt(offset++);
		}

		private void ungetChar(int c) {
			if (c >= 0 && offset > 0)
				offset--;
		}
	}

	/*------------------------------------------------------------------*/

	/**
	 * եƥ
	 */
	public static void main(String argv[]) {
		String format = System.getProperty(LExpr.DEFFORMATKEY);
		boolean verbose = false;
		for (int n = 0; n < argv.length; n++) {
			String s = argv[n];
			if (s.equals("-v")) {
				verbose = true;
				continue;
			}
			if (s.charAt(0) == '-') {
				String name = MathLExprFactory.class.getName();
				System.err.println("[Usage] java " + name + " [-v] format");
				System.err.print("  format:");
				System.err.print(" " + LExpr.MATHFORMAT);
				System.err.print(" " + LExpr.PROPERFORMAT);
				System.err.println();
				return;
			}
			format = s;
		}

		MathLExprFactory factory = new MathLExprFactory(null, null);
		PrintWriter out = new PrintWriter(System.out, true);
		BufferedReader in =
			new BufferedReader(new InputStreamReader(System.in));
		boolean prompt = false;
		try {
			prompt = !in.ready();
		} catch (Exception e) {
			return;
		}
		if (prompt)
			System.err.println("# format=" + format);
		String endMark = ";";
		for ( ; ; ) {
			try {
				if (prompt)
					System.err.print("? ");
				String s = in.readLine();
				if (s == null)
					break;
				s = s.trim();
				if (s.length() <= 0)
					continue;
				if (s.endsWith(endMark))
					s = s.substring(0, s.length()-endMark.length());
				LExpr expr = factory.create(s);
				out.println(expr.getString(format, s.indexOf('') >= 0));
			} catch (Exception e) {
				System.err.println(e.getMessage());
			}
		}
		if (prompt)
			System.err.println();
	}
}
