package mypkg.lambda;

import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
 * ȥ졼Ͼδ
 *
 * Υ饹ϥ׻֥Ȥȥ졼򵭲ν
 * ؽϤ뵡ǽ. νϷʣʤΤǤΥ饹ϥ
 * ʸѴ뵡ǽϻ˴Ԥ.
 */
public class TraceInfo {

	// ------------------------------------------------------------------
	// Υ饹åɥդǤɬפϤʤȻפ뤬, ⤷ɬפ
	// ʤäϽɬפˤʤ. ֤ ThreadLocal Ȥȴñ.
	// ------------------------------------------------------------------

	private List infoList;    // ȥ졼εϿ
	private List exprList;    // 
	private boolean verbose;  // ȥ졼Ϥ٤ʤtrue

	// Ǹ׻ƤΥȥ졼ϼΤƤ뤳Ȥˤʤ.
	// ΥåϼΤƤǽΤTraceInfoץå夷, ݥåפ
	// ˽äƥȥ졼¸뤫ɤ椹.
	private static LinkedList stack = new LinkedList();  // ǤTraceInfo

	/**
	 * Υ饹Υ֥Ȥ֤.
	 */
	public static TraceInfo getInstance() {
		if (stack.size() <= 0)
			stack.addFirst(new TraceInfo());
		return (TraceInfo)stack.getFirst();
	}

	/**
	 * 󥹥ȥ饯
	 */
	private TraceInfo() {
		infoList = new ArrayList();
		exprList = new ArrayList();
		verbose = false;
	}

	/**
	 * ȥ졼ϾνޤϺƽ
	 */
	public void init(boolean verbose) {
		this.verbose = verbose;
		this.infoList.clear();
		this.exprList.clear();
	}

	/**
	 * ȥ졼Ϥ٤ʤtrue֤.
	 * Υ饹ϥȥ졼Ϥ٤ɤȽꤷʤ. Υ᥽åɤ
	 * init()ǻꤵ줿֤Ǥ.
	 */
	public boolean isVerbose() { return verbose; }

	/**
	 * ȥ졼˴ޤޤꥹȤ֤.
	 * Υ饹ˤʸؤѴǽϤʤ.
	 * Υ᥽åɤƤӽФ饹ˤѴǽȲꤷƤεǽ
	 * 󶡤.
	 */
	public List getExprList() {
		return exprList;
	}

	/**
	 * ȥ졼Ϥ.
	 * 裲 getExprArray() ֤ͤʸѴ
	 * ǤʤФʤʤ. 줬٤֤ϤΥ饹ΤäƤ.
	 *
	 * @param out 
	 * @param exprArray getExprArray() ֤ͤʸѴ
	 */
	public void print(PrintWriter out, String exprArray[]) {
		int index = 0;
		for (int n = 0; n < infoList.size(); n++) {
			Printer pr = (Printer)infoList.get(n);
			index = pr.print(out, exprArray, index);
		}
	}

	/**
	 * Ƚreduce()μ¹Է̤ꥹȤɤǷޤ.
	 * äƥȥ졼ϤƤˤ줿κǸ
	 * ȥ졼̵̤Ǥ. ̵̤ʤῷTraceInfoȤ.
	 */
	public static TraceInfo push() {
		TraceInfo newtrinf = new TraceInfo();
		newtrinf.verbose = true;   // push()ȤȤ verbose = true
		stack.addFirst(newtrinf);
		return newtrinf;
	}

	/**
	 * Ϳ줿֥Ƥ򤳤Υ֥Ȥ˥ԡ.
	 *
	 * @param copy TraceInfo򸵤TraceInfo˥ԡ٤ʤtrue
	 */
	public static TraceInfo pop(boolean copy) {
		TraceInfo newtrinf = (TraceInfo)stack.removeFirst();
		TraceInfo orgtrinf = (TraceInfo)stack.getFirst();
		if (copy) {
			orgtrinf.infoList.addAll(newtrinf.infoList);
			orgtrinf.exprList.addAll(newtrinf.exprList);
			newtrinf.infoList.clear();
			newtrinf.exprList.clear();
		}
		return orgtrinf;
	}

	/**
	 * ΥΥȥ졼Ͽ.
	 */
	public void appendTarget(Object expr, int level, String msg) {
		exprList.add(expr);
		infoList.add(new ArgInfo(level, msg));
	}

	/**
	 * ̤ΥΥȥ졼Ͽ.
	 */
	public void appendArray(Object array[], int level, String msg) {
		if (array.length <= 0)
			return;
		for (int n = 0; n < array.length; n++)
			exprList.add(array[n]);
		infoList.add(new ValueInfo(array, level, msg));
	}

	/**
	 * ̤ΥΥȥ졼Ͽ.
	 */
	public void appendList(List list, int level, String msg) {
		if (list.size() <= 0)
			return;
		for (int n = 0; n < list.size(); n++)
			exprList.add(list.get(n));
		infoList.add(new ValueInfo(list, level, msg));
	}

	/**
	 * ̤ΥĤΥȥ졼Ͽ.
	 */
	public void appendResult(Object expr, int level, String msg) {
		if (expr == null)
			return;
		exprList.add(expr);
		infoList.add(new ValueInfo((List)null, level, msg));
	}

	/**
	 * 黻̤Υȥ졼Ͽ.
	 */
	public void appendRedex(Object redex, int level, String msg) {
		exprList.add(redex);
		infoList.add(new SubstInfo(level, msg));
	}

	/*----------------------------------------------------------------*/

	/**
	 * ȤΥȥ졼̤˰Υ󥿥ե
	 */
	private interface Printer {
		int print(PrintWriter out, String exprArray[], int index);
	}

	/**
	 * ΥΥȥ졼Ͽ饹
	 */
	private class ArgInfo implements Printer {
		private int level;
		private String msg;
		ArgInfo(int level, String msg) {
			this.level = level;
			this.msg = msg;
		}
		public int print(PrintWriter out, String exprArray[], int index) {
			for (int n = 0; n < level; n++)
				out.print("  ");
			out.print(exprArray[index++]);
			if (msg != null && msg.length() > 0)
				out.print("  -- " + msg);
			out.println();
			return index;
		}
	}

	/**
	 * ̤ΥΥȥ졼Ͽ饹
	 */
	private class ValueInfo implements Printer {
		private Object array[];
		private List list;
		private int level;
		private String msg;
		ValueInfo(Object array[], int level, String msg) {
			this.array = array;
			this.level = level;
			this.msg = msg;
		}
		ValueInfo(List list, int level, String msg) {
			this.list = list;
			this.level = level;
			this.msg = msg;
		}
		public int print(PrintWriter out, String exprArray[], int index) {
			for (int n = 0; n < level; n++)
				out.print("  ");
			out.print("-> ");
			if (array == null && list == null) {
				out.print(exprArray[index++]);
			} else if (list != null) {
				for (int n = 0; n < list.size(); n++) {
					if (n > 0)
						out.print("; ");
					out.print(exprArray[index++]);
				}
			} else {
				for (int n = 0; n < array.length; n++) {
					if (n > 0)
						out.print("; ");
					out.print(exprArray[index++]);
				}
			}
			if (msg != null && msg.length() > 0)
				out.print("  -- " + msg);
			out.println();
			return index;
		}
	}

	/**
	 * 黻̤Υȥ졼Ͽ饹
	 */
	private class SubstInfo implements Printer {
		private int level;
		private String msg;
		SubstInfo(int level, String msg) {
			this.level = level;
			this.msg = msg;
		}
		public int print(PrintWriter out, String exprArray[], int index) {
			for (int n = 0; n < level; n++)
				out.print("  ");
			out.print(exprArray[index++]);
			if (msg != null && msg.length() > 0)
				out.print("  -- " + msg);
			out.println();
			return index;
		}
	}
}
