package mypkg.lambda;

import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;

/**
 * ѿ -- LExprγĥ饹
 *
 * Ȥ
 *     ѿ |  | ؿŬ
 * Ǥ, Υ饹ѿɽ.
 * Υ饹Υ֥Ȥϥĥ꡼ɽΥ꡼եΡ
 * Ȥʤ.
 */
public class Variable extends LExpr {

	private String name;  // ѿ̾

	/**
	 * 󥹥ȥ饯
	 *
	 * @param name ѿ̾
	 */
	public Variable(String name) {
		if (!checkVariable(name))
			throw new IllegalArgumentException("invalid variable: " + name);
		this.name = name;
	}

	/**
	 * Υ֥ȤΥԡ֤.
	 */
	public Object clone() {
		Variable newexpr = null;
		try {
			newexpr = (Variable)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.name = this.name;
		return newexpr;
	}

	/**
	 * ͳѿ򽸤.
	 */
	protected void gatherFreeVars(Set set) {
		set.add(name);
	}

	/**
	 * Υ֥ȤѿʤФ֤̾.
	 */
	protected String variableName() {
		return name;
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N ͤ M 
	 *     ѿ, , ؿŬ
	 * ξʬƵ.
	 *  (ץߥ󥰸δ ٽ p.18)
	 *
	 *                                   
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  嵭ʳ            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N μͳѿǤϤʤȤ̣.
	 *  [2] ưŪ˦Ѵ뤳Ȥ. ѿ z Ϥޤä̾
	 *        Ф.
	 *
	 * @param param ѿ (x)
	 * @param arg   ° (N)
	 * @param level ƵƽФ٥
	 * @return  黻̤
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		//########## (a) x[x:=N]  N ##########
		//########## (b) y[x:=N]  y ##########
		return param.equals(name) ? arg : this;
	}

	/**
	 * Υ֥ȤΥ֥ȤȦƱͤʤtrue֤.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		if (!(expr instanceof Variable))
			return false;
		String exprname = ((Variable)expr).name;
		for (int n = 0; n < stack.size(); n++) {
			String param[] = (String[])stack.get(n);
			boolean eqx = param[0].equals(name);
			boolean eqy = param[1].equals(exprname);
			if (eqx && eqy)
				return true;   // «ѿȤ.
			if (eqx != eqy)
				return false;  // «ѿȼͳѿ
		}
		if (name.equals(exprname))
			return true;  // ͳѿȤ.
		return false;
	}

	/**
	 * Σƥå׺Ǻ -- Ѵ
	 * ѿϤǤǴǤʤΤǤΥ饹Ǥnull֤.
	 */
	protected LExpr reduce(int level) {
		return null;
	}

	/**
	 * Σƥå״ -- Ѵ
	 * ѿϴǤʤΤǤΥ饹Ǥ϶ꥹȤ֤.
	 */
	protected List reduceAll(int level) {
		return new ArrayList();    // ѿϴǤʤ.
	}

	/**
	 * ǤʷʿŪɽʸ֤.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		return name;
	}

	/**
	 * ʷʿŪɽʸ֤.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		return name;
	}

	/**
	 * ĹʿŪɽʸ֤.
	 *  x.(y.(z.((xy)z)))
	 */
	protected String toProperString(boolean uselambda) {
		return name;
	}

	/**
	 * ͳѿ«ѿ̤٤Ƥѿ򽸤.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void gatherVars(Set set) {
		set.add(name);
	}

	/**
	 * бɽ򻲾Ȥѿ֤̾.
	 * Ѵդ줿֤̾뤿Ūʵǽ.
	 */
	protected void replaceVars(Map map) {
		String newname = (String)map.get(name);
		if (newname != null)
			name = newname;
	}
}
