package mypkg.lambda.util;

import java.io.InputStream;
import java.io.Reader;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.text.MessageFormat;

/**
 * ꥽ɹѤReader
 *
 * Υ饹ϥ˥ɥפ줿Υ꥽ɤ߹.
 * ꥽ native2ascii ˤäѴJARեƱƤ
 * ΤȲꤹ.
 * Ȥ򼨤.
 *
 *     String bundledfile = 
 *     BufferedReader in = new BufferedReader(new ResourceReader(bundledfile));
 *     for ( ; ; ) {
 *         String line = in.readLine();
 *         if (line == null)
 *             break;
 *         // ʸ
 *     }
 */
public class ResourceReader extends Reader {

	private char buffer[];
	private int pointer;

	/**
	 * 󥹥ȥ饯
	 *
	 * @param resource ꥽̾
	 * @param args ° (MessageFormatλ)
	 */
	public ResourceReader(String resource, Object args[]) throws IOException {
		InputStream is = getClass().getResourceAsStream(resource);
		if (is == null)
			throw new FileNotFoundException("resource: " + resource);
		try {
			if (args != null && args.length <= 0)
				args = null;
			buffer = toUnicode(new InputStreamReader(is, "8859_1"), args);
			pointer = 0;
		} finally {
			is.close();
		}
	}

	/**
	 * 󥹥ȥ饯
	 *
	 * @param resource ꥽̾
	 */
	public ResourceReader(String resource) throws IOException {
		this(resource, null);
	}

	/**
	 * 󥹥ȥ饯
	 *
	 * @param is ϤInputStream
	 * @param args ° (MessageFormatλ)
	 */
	public ResourceReader(InputStream is, Object args[]) throws IOException {
		if (args != null && args.length <= 0)
			args = null;
		buffer = toUnicode(new InputStreamReader(is, "8859_1"), args);
		pointer = 0;
	}

	/**
	 * 󥹥ȥ饯
	 *
	 * @param is ϤInputStream
	 */
	public ResourceReader(InputStream is) throws IOException {
		this(is, null);
	}

	/**
	 * 
	 */
	public void close() throws IOException { buffer = null; }

	/**
	 * ХåեϤ.
	 */
	public int read(char cbuf[], int off, int len) throws IOException {
		int rest = buffer.length - pointer;
		if (rest <= 0)
			return -1;
		int size = (rest < len) ? rest : len;
		System.arraycopy(buffer, pointer, cbuf, off, size);
		pointer += size;
		return size;
	}

	/**
	 * ʸϤ֤.
	 */
	public int read() throws IOException {
		return (pointer < buffer.length) ? buffer[pointer++] : -1;
	}

	/**
	 * ˥ɥפ줿ʸ˥ʸѴ.
	 *
	 * @param r ϤReader
	 * @return ˥ɤ
	 */
	private char[] toUnicode(Reader r, Object args[]) throws IOException {
		StringBuffer sb = new StringBuffer();
		String eol = System.getProperty("line.separator");
		BufferedReader in = (r instanceof BufferedReader)
			? (BufferedReader)r : new BufferedReader(r);
		/*
		 * ñ̤ǽƤΤǲԥɤϼ¹ԥƥΥɤȤʤ.
		 */
		for (String line = null; (line = in.readLine()) != null; ) {
			String s = toUnicode(line);
			if (args != null && line.indexOf('{') >= 0)
				s = MessageFormat.format(s, args);
			sb.append(s).append(eol);
		}
		return sb.toString().toCharArray();
	}

	/**
	 * ˥ɥפ줿ʸ˥ʸѴ.
	 *
	 * @param s ˥ɥפޤʸ
	 * @return ˥ʸ
	 */
	private String toUnicode(String s) {
		StringBuffer sb = new StringBuffer();
		for (int len = s.length(), n = 0; n < len; n++) {
			char c1 = s.charAt(n);
			if (c1 != '\\' || n+5 >= len) {
				sb.append(c1);
				continue;
			}
			char c2 = s.charAt(++n);
			if (c2 != 'u') {
				sb.append(c1).append(c2);
				continue;
			}
			int value = getValue(s, n+1);
			if (value < 0) {
				sb.append(c1).append(c2);
			} else {
				sb.append((char)value);
				n += 4;
			}
		}
		return sb.toString();
	}

	/**
	 * ֤飴ʸʾ夢뤳ȤϸƽФ¦ݾڤ뤳.
	 */
	private int getValue(String s, int off) {
		int value = 0;
		for (int end = off + 4; off < end; off++) {
			char c = s.charAt(off);
			if ('0' <= c && c <= '9')
				value = (value << 4) + c - '0';
			else if ('a' <= c && c <= 'f')
				value = (value << 4) + c - 'a' + 10;
			else if ('A' <= c && c <= 'F')
				value = (value << 4) + c - 'A' + 10;
			else
				return -1;
		}
		return value;
	}
}
