package mypkg.lambda;

import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;

/**
 * _ -- _LExpr̊gNX
 *
 * _Ƃ
 *     ϐ | _ | ֐Kp
 * ł, ̃NX̓_ۂ\.
 *
 * _ۂƂ̓vO~O̗pgΊ֐`̂Ƃł.
 * _ۂ𐔊wIɕ\
 *     x.M
 * ƂȂ. 
 *     x: ϐ
 *     M: ֐{̂\_
 * Ƃ.
 *
 * ̃NX̃IuWFNg̓_c[ŕ\ꍇ̃m[hƂȂ.
 */
public class Abstraction extends LExpr {

	private String parameter;  // ϐ ()
	private LExpr expression;  // _ (֐{)

	// g[X̃Rg
	protected static final String
		REDEX    = "(x.M)NM[x:=N]",
		ABS_STEP = "x.Mx.N if MN",
		ETA_STEP = "x.MxM (eta)";

	/**
	 * RXgN^
	 *
	 * @param parameter  ϐ
	 * @param expression _
	 */
	public Abstraction(String parameter, LExpr expression) {
		if (!checkVariable(parameter))
			throw new IllegalArgumentException("invalid param: " + parameter);
		this.parameter = parameter;
		this.expression = expression;
	}

	/**
	 * ̃IuWFNg̃Rs[Ԃ.
	 */
	public Object clone() {
		Abstraction newexpr = null;
		try {
			newexpr = (Abstraction)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.parameter = this.parameter;
		newexpr.expression = (LExpr)this.expression.clone();
		return newexpr;
	}

	/**
	 * ̃IuWFNg_ x.M Ȃ΂̉ x Ԃ.
	 */
	protected String parameterName() {
		return parameter;
	}

	/**
	 * ̃IuWFNg_ x.M Ȃ΂̊֐{ M Ԃ.
	 */
	protected LExpr getBody() {
		return expression;
	}

	/**
	 * RϐW߂.
	 */
	protected void gatherFreeVars(Set set) {
		expression.gatherFreeVars(set);
		set.remove(parameter);
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N l M 
	 *     ϐ, _, ֐Kp
	 * ̏ꍇɕċ߂.
	 * ̒` (vO~O̊b_ x~ p.18)
	 *
	 *        `                           
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  LȊO            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N ̎Rϐł͂ȂƂӖ.
	 *  [2] IɃϊ邱Ƃɒ. ϐ z ͂܂VO
	 *        I΂.
	 *
	 * svȃῗł邾ʂ𗝉₷.
	 * ĐVϐouniqueVariable()̌ĂяoȂ
	 * ASY͏dvł.
	 *
	 * @param param ɑϐ (x)
	 * @param arg   ɑ郉_ (N)
	 * @param level ċAďox
	 * @return  Zʂ̒l
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		LExpr value = null;
		if (param.equals(parameter)) {
			//########## (c) (y.M)[x:=N]  y.M ##########
			value = new Abstraction(parameter, expression);
		} else if (paramAvailable(this, param, arg)) {
			/*
			 * ̂悤ȏꍇɒ.
			 *     (x.y.x)y.z -> y.y.z
			 * ͂Ԃł胿ϊׂP[Xł.
			 */
			//########## (d) (y.M)[x:=N]  y.M[x:=N] ##########
			LExpr expr = expression.substitute(param, arg, level+1);
			value = new Abstraction(parameter, expr);
		} else {
			//########## (e) (y.M)[x:=N]  z.M[y:=z][x:=N] ##########
			// IɃϊs.
			LExpr var = LExpr.uniqueVariable();
			LExpr expr = expression.substitute(parameter, var, level+1);
			LExpr nexpr = expr.substitute(param, arg, level+1);
			value = new Abstraction(var.variableName(), nexpr);
		}
		return value;
	}

	/**
	 * _̂PXebvȖ񏈗 -- -redex̏ꍇ
	 * -redexƂ(x.M)Ň`̃_Ӗ.
	 * ̃\bh͑Ώۂ x.M ł arg  N ƂČĂяo.
	 */
	protected LExpr reduceRedex(LExpr arg, int level) {
		//########## (A) (x.M)N  M[x:=N] ##########
		LExpr value = expression.substitute(parameter, arg, level);
		TraceInfo trinf = TraceInfo.getInstance();
		if (trinf.isVerbose()) {
			LExpr redex = getInstance(expression, parameter, arg);
			trinf.appendRedex(redex, level, REDEX);
		}
		return value;
	}

	/**
	 * _̂PXebvōȖ񏈗 -- ϊ
	 * ̃\bh͍ōȖ񂳂ꂽ_PԂ.
	 *
	 * ϊ̒` (vZ_ q p.65)
	 * L̓ϊӖ̂Ƃ.
	 *
	 *        K                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N Ȃ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N Ȃ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N Ȃ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * Ƃ΂̃IuWFNg(this)
	 *     ((a.b)c)((x.y)z)
	 * Ƃ
	 *     b((x.y)z)
	 * Ԃ.
	 *
	 * @param level ċAďox
	 * @return  PXebvōȖ񌋉ʂ̃_ (łɐK`Ȃnull)
	 */
	protected LExpr reduce(int level) {
		//########## (B) M  N Ȃ x.M  x.N ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (!noEtaConversion) {
			LExpr value = this.etaConversion(null);
			if (value != null) {
				if (verbose)
					trinf.appendTarget(this, level+1, ETA_STEP);
				return value;
			}
		}
		if (verbose) {
			trinf = trinf.push();
			if (expression.variableName() == null)
				trinf.appendTarget(expression, level+1, ABS_STEP);
		}
		LExpr expr = expression.reduce(level+1);
		if (verbose) {
			trinf.appendResult(expr, level+1, ABS_STEP);
			trinf.pop(expr != null);
		}
		if (expr != null) {
			// { M ̊Ȗ񌋉ʂ_ۉ.
			return new Abstraction(parameter, expr);
		}
		return null;
	}

	/**
	 * _̂PXebvȖ񏈗 -- ϊ
	 * ̃\bh͍ōȖ񂾂ł͂ȂׂĂ̊Ȗ񌋉ʂԂ.
	 *
	 * ϊ̒` (vZ_ q p.65)
	 * L̓ϊӖ̂Ƃ.
	 *
	 *        K                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N Ȃ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N Ȃ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N Ȃ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * PXebvȖ̌ʂ͕蓾̂, ̃\bhList<LExpr>^
	 * ̒lԂ. Ƃ΂̃IuWFNg(this)
	 *     ((a.b)c)((x.y)z)
	 * Ƃ
	 *     [b((x.y)z); ((a.b)c)y]
	 * Ԃ.
	 *
	 * Ȗ񌋉ʂꍇ͍ōȖ񂪐擪vfƂȂASYƂȂ
	 * . ĐK`߂邽߂ɂ̃\bhĂяoꍇ͍ō
	 * Ȗ񂾂擾ΖʂȌvZȗł.
	 * ׂĂ̊Ȗ񌋉ʂ߂@\, mF, Ȗ@ɂ
	 * ͒~ȂƂȂǂmF邽߂ɗpӂĂ.
	 *
	 * @param level ċAďox
	 * @return  PXebvȖ񌋉ʂ̃Xg
	 */
	protected List reduceAll(int level) {
		//########## (B) M  N Ȃ x.M  x.N ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (!noEtaConversion) {
			LExpr value = this.etaConversion(null);
			if (value != null) {
				List list = new ArrayList();
				appendLExpr(list, value);
				if (verbose)
					trinf.appendTarget(this, level+1, ETA_STEP);
				return list;
			}
		}
		if (verbose && expression.variableName() == null)
			trinf.appendTarget(expression, level+1, ABS_STEP);
		List list = expression.reduceAll(level+1);
		if (verbose)
			trinf.appendList(list, level+1, ABS_STEP);
		for (int n = 0; n < list.size(); n++) {
			// { M ̊Ȗ񌋉ʂ_ۉ.
			list.set(n, new Abstraction(parameter, (LExpr)list.get(n)));
		}
		return list;
	}

	/**
	 * IȃϊKvǂ𒲂ׂ.
	 * Ƃ
	 *     (x.y.x)y.z
	 * ̌vZߒł
	 *     body=y.x  param=x  arg=y.z
	 * ̏ł̃\bhĂяo. trueԂ
	 *     y.y.z
	 * ƂȂĂ܂.
	 *
	 * @param body ֐{̂ɑ郉_ (Abstraction^Ɍ)
	 * @param param ɑϐ
	 * @param arg 
	 * @return ϊKvȂtrue
	 */
	private boolean paramAvailable(Abstraction body, String param, LExpr arg) {
		String bodyparam = body.parameter;
		LExpr bodyexpr = body.expression;
		if (param.equals(bodyexpr.variableName())) {
			for (LExpr e = arg; e instanceof Abstraction; ) {
				if (bodyparam.equals(((Abstraction)e).parameter))
					return false;  // ϊKv
				e = ((Abstraction)e).expression;
			}
		}
		return !arg.freeVariables().contains(bodyparam);
	}

	/**
	 * ̃IuWFNg̃IuWFNgƃlȂtrueԂ.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		if (!(expr instanceof Abstraction))
			return false;
		Abstraction abs = (Abstraction)expr;
		LExpr body = abs.expression;
		if (expression.getClass() != body.getClass())
			return false;
		/*
		 * Ή鑩ϐ̑΂X^bNɐς.
		 */
		stack.addFirst(new String[]{parameter, abs.parameter});
		boolean result = expression.isEquivalent(body, stack, level);
		stack.removeFirst();
		return result;
	}

	/**
	 * ŕϊ
	 *     (x.Mx)N = MN  x ! FV(M)
	 * ł邱Ƃl
	 *     x.Mx = M
	 * ɒu\ł.
	 */
	protected LExpr etaConversion(String param) {
		if (expression.getFunction() != null)
			return expression.etaConversion(parameter);
		return null;
	}

	/**
	 * ̃IuWFNgChurchȂΐlԂ.
	 * łȂ IllegalStateException X[.
	 * ̃NXł͈QƂȂ.
	 */
	protected int getChurchNumeral(String succ, String zero) {
		if (!(expression instanceof Abstraction))
			throw new IllegalStateException();
		Abstraction body = (Abstraction)expression;
		succ = parameter;
		zero = body.parameter;
		return body.expression.getChurchNumeral(succ, zero);
	}

	/**
	 * łȌȐwI\̕Ԃ.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		String lambda = uselambda ? LAMBDA : "\\";
		String body = expression.toAbbrevString(uselambda);
		StringBuffer sb = new StringBuffer();
		sb.append(lambda).append(parameter).append(".").append(body);
		return sb.toString();
	}

	/**
	 * ȌȐwI\̕Ԃ.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		String lambda = uselambda ? LAMBDA : "\\";
		String body = expression.toMathString(uselambda);
		StringBuffer sb = new StringBuffer();
		sb.append(lambda).append(parameter).append(".").append(body);
		return sb.toString();
	}

	/**
	 * 璷ȐwI\̕Ԃ.
	 *  x.(y.(z.((xy)z)))
	 */
	protected String toProperString(boolean uselambda) {
		String lambda = uselambda ? LAMBDA : "\\";
		StringBuffer sb = new StringBuffer();
		sb.append(lambda).append(parameter).append(".");
		sb.append(parenthesize(expression.toProperString(uselambda)));
		return sb.toString();
	}

	/**
	 * RϐϐʂׂĂ̕ϐW߂.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void gatherVars(Set set) {
		set.add(parameter);
		expression.gatherVars(set);
	}

	/**
	 * Ή\QƂĕϐu.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void replaceVars(Map map) {
		String newparam = (String)map.get(parameter);
		if (newparam != null)
			parameter = newparam;
		expression.replaceVars(map);
	}
}
