package mypkg.lambda;

import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;

/**
 * ֐Kp -- _LExpr̊gNX
 *
 * _Ƃ
 *     ϐ | _ | ֐Kp
 * ł, ̃NX͊֐Kp\.
 *
 * ֐KpƂ̓vO~O̗pgΊ֐ďoɑ.
 * ֐Kp𐔊wIɕ\
 *     MN
 * ƂȂ.  M, N ͔Cӂ̃_Ƃ.
 * ֐Kp͍Ił. ܂ LMN  (LM)N ̈Ӗł.
 *
 * ̃NX̃IuWFNg̓_c[ŕ\ꍇ̃m[hƂȂ.
 */
public class Application extends LExpr {

	// CX^Xϐ left, right ̓c[m[hz肵Ă.

	private LExpr left;   // ֐Kp_̑1
	private LExpr right;  // ֐Kp_̑2

	// g[X̃Rg
	protected static final String
		E1_STEP  = "MPNP if MN",
		E2_STEP  = "PMPN if MN";

	/**
	 * RXgN^
	 *
	 * @param left  ֐Kp_̑1
	 * @param right ֐Kp_̑2
	 */
	public Application(LExpr left, LExpr right) {
		this.left = left;
		this.right = right;
	}

	/**
	 * ̃IuWFNg̃Rs[Ԃ.
	 */
	public Object clone() {
		Application newexpr = null;
		try {
			newexpr = (Application)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.left = (LExpr)this.left.clone();
		newexpr.right = (LExpr)this.right.clone();
		return newexpr;
	}

	/**
	 * ̃IuWFNg֐Kp MN Ȃ΂̊֐ M Ԃ.
	 */
	protected LExpr getFunction() {
		return left;
	}

	/**
	 * ̃IuWFNg֐Kp MN Ȃ΂̈ N Ԃ.
	 */
	protected LExpr getArgument() {
		return right;
	}

	/**
	 * RϐW߂.
	 */
	protected void gatherFreeVars(Set set) {
		left.gatherFreeVars(set);
		right.gatherFreeVars(set);
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N l M 
	 *     ϐ, _, ֐Kp
	 * ̏ꍇɕċ߂.
	 * ̒` (vO~O̊b_ x~ p.18)
	 *
	 *        `                           
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  LȊO            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N ̎Rϐł͂ȂƂӖ.
	 *  [2] IɃϊ邱Ƃɒ. ϐ z ͂܂VO
	 *        I΂.
	 *
	 * @param param ɑϐ (x)
	 * @param arg   ɑ郉_ (N)
	 * @param level ċAďox
	 * @return  Zʂ̒l
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		//########## (f) (M1M2)[x:=N]  M1[x:=N]M2[x:=N] ##########
		LExpr lexpr = left.substitute(param, arg, level+1);
		LExpr rexpr = right.substitute(param, arg, level+1);
		return new Application(lexpr, rexpr);
	}

	/**
	 * ̃IuWFNg̃IuWFNgƃlȂtrueԂ.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		if (!(expr instanceof Application))
			return false;
		Application app = (Application)expr;
		return left.isEquivalent(app.left, stack, level)
			&& right.isEquivalent(app.right, stack, level);
	}

	/**
	 * ŕϊ
	 *     (x.Mx)N = MN  x ! FV(M)
	 * ł邱Ƃl
	 *     x.Mx = M
	 * ɒu\ł.
	 */
	protected LExpr etaConversion(String param) {
		if (param.equals(right.variableName()))
			if (!left.freeVariables().contains(param))
				return left;
		return null;
	}

	/**
	 * _̂PXebvōȖ񏈗 -- ϊ
	 * ̃\bh͍ōȖ񂳂ꂽ_PԂ.
	 *
	 * ϊ̒` (vZ_ q p.65)
	 * L̓ϊӖ̂Ƃ.
	 *
	 *        K                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N Ȃ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N Ȃ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N Ȃ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * Ƃ΂̃IuWFNg(this)
	 *     ((a.b)c)((x.y)z)
	 * Ƃ
	 *     b((x.y)z)
	 * Ԃ.
	 *
	 * @param level ċAďox
	 * @return  PXebvōȖ񌋉ʂ̃_ (łɐK`Ȃnull)
	 */
	protected LExpr reduce(int level) {
		if (left.getBody() != null) {
			//########## (A) (x.M)N  M[x:=N] ##########
			return left.reduceRedex(right, level+1);
		}
		//########## (C) M  N Ȃ MP  NP ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (verbose) {
			trinf = trinf.push();
			if (left.variableName() == null)
				trinf.appendTarget(left, level+1, E1_STEP);
		}
		LExpr expr1 = left.reduce(level+1);
		if (verbose) {
			trinf.appendResult(expr1, level+1, E1_STEP);
			trinf.pop(expr1 != null);
		}
		if (expr1 != null)
			return new Application(expr1, right);
		//########## (D) M  N Ȃ PM  PN ##########
		if (verbose) {
			trinf = trinf.push();
			if (right.variableName() == null)
				trinf.appendTarget(right, level+1, E2_STEP);
		}
		LExpr expr2 = right.reduce(level+1);
		if (verbose) {
			trinf.appendResult(expr2, level+1, E2_STEP);
			trinf.pop(expr2 != null);
		}
		if (expr2 != null)
			return new Application(left, expr2);
		return null;
	}

	/**
	 * _̂PXebvȖ񏈗 -- ϊ
	 * ̃\bh͍ōȖ񂾂ł͂ȂׂĂ̊Ȗ񌋉ʂԂ.
	 *
	 * ϊ̒` (vZ_ q p.65)
	 * L̓ϊӖ̂Ƃ.
	 *
	 *        K                              
	 *   -----------------------------------------------------------
	 *   (A)  (x.M)N  M[x:=N]              (x.x)M  M
	 *                                         (x.y)M -> y
	 *                                         (x.y.x)z  y.z
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (B)  M  N Ȃ x.M  x.N     x.(y.y)x  x.x
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (C)  M  N Ȃ MP  NP           (a.b)cd  bd
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (D)  M  N Ȃ PM  PN           x((x.y)z)  xy
	 *   -----------------------------------------------------------
	 *
	 * PXebvȖ̌ʂ͕蓾̂, ̃\bhList<LExpr>^
	 * ̒lԂ. Ƃ΂̃IuWFNg(this)
	 *     ((a.b)c)((x.y)z)
	 * Ƃ
	 *     [b((x.y)z); ((a.b)c)y]
	 * Ԃ.
	 *
	 * Ȗ񌋉ʂꍇ͍ōȖ񂪐擪vfƂȂASYƂȂ
	 * . ĐK`߂邽߂ɂ̃\bhĂяoꍇ͍ō
	 * Ȗ񂾂擾ΖʂȌvZȗł.
	 * ׂĂ̊Ȗ񌋉ʂ߂@\, mF, Ȗ@ɂ
	 * ͒~ȂƂȂǂmF邽߂ɗpӂĂ.
	 *
	 * @param level ċAďox
	 * @return  PXebvȖ񌋉ʂ̃Xg
	 */
	protected List reduceAll(int level) {
		List list = new ArrayList();
		if (left.getBody() != null) {
			//########## (A) (x.M)N  M[x:=N] ##########
			appendLExpr(list, left.reduceRedex(right, level+1));
		}
		//########## (C) M  N Ȃ MP  NP ##########
		TraceInfo trinf = TraceInfo.getInstance();
		boolean verbose = trinf.isVerbose();
		if (verbose && left.variableName() == null)
			trinf.appendTarget(left, level+1, E1_STEP);
		List list1 = left.reduceAll(level+1);
		if (verbose)
			trinf.appendList(list1, level+1, E1_STEP);
		for (int n = 0; n < list1.size(); n++) {
			appendLExpr(list, new Application((LExpr)list1.get(n), right));
		}
		//########## (D) M  N Ȃ PM  PN ##########
		if (verbose && right.variableName() == null)
			trinf.appendTarget(right, level+1, E2_STEP);
		List list2 = right.reduceAll(level+1);
		if (verbose)
			trinf.appendList(list2, level+1, E2_STEP);
		for (int n = 0; n < list2.size(); n++) {
			appendLExpr(list, new Application(left, (LExpr)list2.get(n)));
		}
		return list;
	}

	/**
	 * ̃IuWFNgChurch̕ȂΐlԂ.
	 * łȂ IllegalStateException X[.
	 */
	protected int getChurchNumeral(String succ, String zero) {
		if (succ == null || zero == null)
			throw new IllegalStateException();
		int number = 0;
		LExpr e = this;
		for ( ; e.getFunction() != null; e = ((Application)e).right) {
			LExpr left = ((Application)e).left;
			if (!succ.equals(left.variableName()))
				throw new IllegalStateException();
			number++;
		}
		if (!zero.equals(e.variableName()))
			throw new IllegalStateException();
		return number;
	}

	/**
	 * łȌȐwI\̕Ԃ.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		String ls = left.toAbbrevString(uselambda);
		String rs = right.toAbbrevString(uselambda);
		String s1 = mustParenthesizeLeft() ? parenthesize(ls) : ls;
		String s2 = mustParenthesizeRight() ? parenthesize(rs) : rs;
		return s1 + s2;
	}

	/**
	 * ȌȐwI\̕Ԃ.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		String ls = left.toMathString(uselambda);
		String rs = right.toMathString(uselambda);
		String s1 = mustParenthesizeLeft() ? parenthesize(ls) : ls;
		String s2 = mustParenthesizeRight() ? parenthesize(rs) : rs;
		return s1 + s2;
	}

	/**
	 * 璷ȐwI\̕Ԃ.
	 *  x.(y.(z.((xy)z)))
	 */
	protected String toProperString(boolean uselambda) {
		String ls = left.toProperString(uselambda);
		String rs = right.toProperString(uselambda);
		return parenthesize(ls) + parenthesize(rs);
	}

	/**
	 * ̃IuWFNg̊ȌȐwI\ɂđ1()ɊʂKv
	 * ȂtrueԂ.
	 *     left     right   toMathString()
	 *   -----------------------------------
	 *     x.y      M       (x.y)M
	 *     xyx.y    M       (xyx.y)M
	 */
	private boolean mustParenthesizeLeft() {
		if (left.getBody() != null)
			return true;
		if (left.getFunction() != null)
			if (((Application)left).right.getBody() != null)
				return true;
		return false;
	}

	/**
	 * ̃IuWFNg̊ȌȐwI\ɂđ2(E)ɊʂKv
	 * ȂtrueԂ.
	 *     left   right   toMathString()
	 *   ---------------------------------
	 *      xy    zx.y    xy(zx.y)
	 */
	private boolean mustParenthesizeRight() {
		return right.getFunction() != null;
	}

	/**
	 * RϐϐʂׂĂ̕ϐW߂.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void gatherVars(Set set) {
		left.gatherVars(set);
		right.gatherVars(set);
	}

	/**
	 * Ή\QƂĕϐu.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void replaceVars(Map map) {
		left.replaceVars(map);
		right.replaceVars(map);
	}
}
