package mypkg.lambda;

import java.io.PrintWriter;
import java.io.IOException;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.Map;
import java.util.Iterator;
import java.lang.reflect.Constructor;

/**
 * _vZC^tF[X̎
 *
 * _vZNXLambdaCalculusϏ
 *   E񂩂烉_ւ̕ϊ
 *   E_̌vZʂ̏o
 *   E_̌vZ
 *   E}N̊Ǘ
 *   EԂ̊Ǘ
 *       Ȗ񐔂̏l -- vZ~Ȃꍇ̉񐔂őł؂.
 *       _̏o͌` -- xy.xyz | x.y.xyz | x.(y.((xy)z))
 *       vZʂ}Nɖ߂ǂ
 * 𕪒S.
 * ̃NX񋟂C^tF[X LExprHandler ̓_(LExpr)
 * mقƂǕKvƂɃ_vZsƂړIƂĐ݌vĂ.
 *
 * VXevpeB
 * ~~~~~~~~~~~~~~~~~~
 * EȖ񐔂̏l̏l lambdacalc.maxsteps
 *   vZ~ȂƂ̔@ƂĊȖ񐔂`FbN.
 *   ̒l͂̏lƂĎg.
 *   ftHgl: 10000
 * Eo͂Ƀ}NgȂƂw肷_^vpeB lambdacalc.nomacro
 *   \Ȓl: true ܂ false (` false)
 *   ftHgl: false
 */
public class ExpressionHandler implements LExprHandler {

	// ̃NXˑ͉̂L̃NXł.
	// Emypkg.lambda.LExprHandler   _vZC^tF[X
	// Emypkg.lambda.LExprFactory   _쐬C^tF[X
	// Emypkg.lambda.LExprConverter }N@\ǉC^tF[X
	// Emypkg.lambda.LExpr          _\ۃNX
	// Emypkg.lambda.ResultValue    _vŽvZ
	// Emypkg.lambda.TraceInfo      g[Xo͏̊Ǘ
	//
	// _͂̃NXł͒ۓIɈĂ̂Ń_̃TuNX
	// (ϐE_ہE֐Kp)Ƃ̐ÓIȈˑ͂Ȃ. ̍ۂɒ.
	//
	// _(LExpr)̓_vZ@\Ă̂
	//     LExpr value = expr.reduce();
	// ̂悤ȋLq\ł.
	// ̃NX̗p҂͂̃NXIy[^, LExprIyh
	// ̂悤ɍl
	//     LExpr value = handler.convert(expr);
	// ƋLqȂ΂ȂȂ. LExprɊւm͂قƂǕKvȂ.

	private LExprFactory factory;
	private LExprConverter converter;

	private int maxSteps;         // Ȗ񐔂̏l
	private String format;        // _̏o͌`
	private boolean useMacro;     // vZʂ̃_Ƀ}Ng.

	private final String macroStart;    // }NQƂ̊JnL
	private final String macroEnd;      // }NQƂ̏IL

	private final String False;
	private final String True;
	private final String Zero;
	private final String Number;

	private static final String PREFIX = LExpr.PREFIX;

	private static final String FORMATLIST[] = {
		// ǉƂLISP̂lrȂ
		LExpr.ABBREVFORMAT, LExpr.MATHFORMAT, LExpr.PROPERFORMAT,
	};
	private static final String FORMATDESC[] = {
		LExpr.ABBREVFORMAT + " łȌȐwI\   [] xy.xyz",
		LExpr.MATHFORMAT + "   ȌȒʏ̐wI\ [] x.y.xyz",
		LExpr.PROPERFORMAT + " ʂ̑wI\   [] x.(y.((xy)z))",
	};

	private static final String
		INVALID = "invalid syntax",
		NULLNAME = "macro name is null",
		EMPTYNAME = "macro name is empty",
		AMBIGUOUS = "ambiguous arg",
		INVALARG = "invalid arg",
		INVALNAME = "invalid macro name";

	/**
	 * RXgN^
	 *
	 * @param mstart }NQƂ̊JnL
	 * @param mend }NQƂ̏IL
	 * @param w  IuWFNg쐬̃g[Xo͐ (nullȂ΃g[XȂ)
	 */
	public ExpressionHandler(String mstart, String mend, PrintWriter w)
			throws IOException {

		macroStart = mstart;
		macroEnd = mend;
		False = macroStart + "false" + macroEnd;
		True = macroStart + "true" + macroEnd;
		Zero = macroStart + "0" + macroEnd;
		Number = ".*" + macroStart + "[0-9]+" + macroEnd + ".*";

		converter = createConverter(macroStart, macroEnd);
		factory = createFactory(converter, w);

		String s = System.getProperty(PREFIX + "maxsteps");
		maxSteps = (s != null && s.length() > 0) ? Integer.parseInt(s) : 1000;
		useMacro = !"true".equals(System.getProperty(PREFIX + "nomacro"));
		initFormat(System.getProperty(LExpr.DEFFORMATKEY, LExpr.ABBREVFORMAT));
	}

	/**
	 * _LExpr^̃_ɕϊ.
	 *
	 * @param s ϊΏۂ̕
	 * @return  _ (LExpr^)
	 */
	public LExpr createLExpr(String s) {
		return toLExpr(s);
	}

	/**
	 * LExpr^̃_o͂.
	 * ̓_ɒӂ.
	 * Eʂ}Nɒuw肪Ă͂ꂽ_
	 *   }NgĂȂ΃}NɒuȂ.
	 * Efalse  0 ͂܂Ȃ̂œ͂ꂽ_Ó
	 *   łI.
	 *
	 * @param out     o͐
	 * @param expr    o͑Ώۂ̃_
	 * @param s       ͂ꂽ_ (͎̏QƂ邽)
	 * @param verbose g[Xo͂.
	 */
	public void print(PrintWriter out, LExpr expr, String s, boolean verbose) {
		if (verbose)
			printTraceInfo(s, out);
		printLExpr(out, expr, s);
	}

	/**
	 * w̃_̐K`߂.
	 *
	 * _̊ȖJԂĐK`߂.
	 * Ȗ񌋉ʂꍇ, ŏ̌ʂJԂvZ.
	 * Ȗ\łΌʂ͈ӂɌ܂.
	 *  [vZ]
	 *     ((a.b)c)((x.y)z) --step--> [b((x.y)z); ((a.b)c)y]
	 *     b((x.y)z) --step--> [by]
	 * #################################################################
	 * _K`Ȃ΍łÕfbNX̂ōł
	 * ̂̂Ȗ񂷂邱ƂŕKK`.
	 * Ƃ
	 *     (x.y)((x.xx)(x.xx)))
	 *  (x.xx)(x.xx) ̊ȖɍsƖ̊Ȗ񂪑 (x.y)M
	 * ƌ΂P̊Ȗ y ƂȂ.
	 * #################################################################
	 *
	 * vZ~ȂꍇnulľvZʂResultValueԂ.
	 * vZ~ȂƂ͈Ŏw肳ꂽȖ񐔂̏
	 * ꍇƂ.
	 *
	 * @param expr vZΏۂ̃_
	 * @param verbose trueȂ΃_Ȗ񎞂̃g[XL^
	 * @return  K`̃_, Ȗ, vԂێIuWFNg
	 *          vZ~Ȃꍇ̓_null̃IuWFNg
	 *          ̃_nullȂnull
	 */
	public ResultValue normalize(LExpr expr, boolean verbose) {
		if (expr == null)
			return null;
		// g[Xo͐̏
		TraceInfo.getInstance().init(verbose);
		// j[Nȕϐ쐬@\̏
		LExpr.init();
		// Ȗ񐔂ƏvԂv.
		int nsteps = 0;
		long t = System.currentTimeMillis();
		for ( ; ; nsteps++) {
			if (nsteps >= maxSteps) {
				// [] (x.xx)(x.xx)
				expr = null;
				break;
			}
			LExpr newexpr = reduce(expr);
			if (newexpr == null)
				break;
			expr = newexpr;
		}
		long time = System.currentTimeMillis() - t;
		if (expr != null)
			expr = expr.reshape();
		return new ResultValue(expr, nsteps, time);
	}

	/**
	 * _ׂ̂Ă̂PXebvȖ񌋉ʂԂ.
	 * PXebvȖ̌ʂ͕蓾̂, ̃\bhLExpr[]^
	 * ̒lԂ.
	 *
	 * @param expr  ȖΏۂ̃_
	 * @return  PXebvȖ񂳂ꂽ_̔z
	 */
	public LExpr[] step(LExpr expr) {
		// g[Xo͐̏ (݂̎dl̓g[XȂ)
		boolean verbose = false;
		TraceInfo.getInstance().init(verbose);
		LExpr array[] = reduceAll(expr);
		for (int n = 0; n < array.length; n++)
			array[n] = array[n].reshape();
		return array;
	}

	/**
	 * ^ꂽ_PXebvōȖ񂵂_Ԃ.
	 * step()Ƃ̈Ⴂ͍ōȖ񂾂vZ邱Ƃł.
	 * normalize()͂̃\bh𐳋K`ɓB܂ŌJԂʂԂ.
	 *
	 * @param expr ȖΏۂ̃_
	 * @param verbose g[Xo
	 * @return ōȖ񂳂ꂽ_ (łɐK`ȂnullԂ.)
	 */
	public LExpr convert(LExpr expr) {
		// g[Xo͐̏ (݂̎dl̓g[XȂ)
		boolean verbose = false;
		TraceInfo.getInstance().init(verbose);
		LExpr newexpr = reduce(expr);
		return (newexpr != null) ? newexpr.reshape() : null;
	}

	/**
	 * M[x:=N] ܂ [N/x]M ̌`̕߂đŽʂԂ.
	 *
	 * @param s ϊΏۂ̕ ("M[x:=N]" ܂ "[N/x]M")
	 * @return  Zʂ̃_
	 */
	public LExpr substitute(String s) {
		if (s.length() <= 0)
			return null;
		try {
			LExpr redex = factory.parseSubstitution(s);
			LExpr body = redex.getBodyOfRedex();
			String param = redex.getParamOfRedex();
			LExpr arg = redex.getArgOfRedex();
			return body.substitute(param, arg).reshape();
		} catch (Exception e) {
			throw new IllegalArgumentException(INVALID + arg(s));
		}
	}

	/**
	 * ^ꂽ_̎Rϐ̏WԂ.
	 *
	 * @param expr Ώۂ̃_
	 * @return  _̎Rϐ̏W
	 */
	public Set freeVariables(LExpr expr) {
		return expr.freeVariables();
	}

	/**
	 * }N`.
	 *
	 * @param name  }N
	 * @param value l
	 */
	public void defineMacro(String name, String value) {
		define(name, value);
		// }Ñ[fBOƂʒm.
		converter.initMacros();
	}

	/**
	 * ^ꂽΉ\̃}N`.
	 *
	 * @param map }Nƒl̑Ή\
	 */
	public void defineMacros(Map map) {
		for (Iterator i = map.keySet().iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			String value = (String)map.get(name);
			define(name, value);
		}
		// }Ñ[fBOƂʒm.
		converter.initMacros();
	}

	/**
	 * }N`̈ꗗo͂.
	 *
	 * @param out o͐
	 * @param msg ꗗ̑Oɏo͂ (nullȂΏo͂Ȃ)
	 */
	public void printMacros(PrintWriter out, String msg) {
		converter.printMacros(out, msg);
	}

	/**
	 * Ȗ񐔂̏lݒ肷.
	 *
	 * @param maxSteps Ȗ񐔂̏l
	 */
	public void setMaxSteps(int maxSteps) { this.maxSteps = maxSteps; }

	/**
	 * ݒ肳ĂȖ񐔂̏lԂ.
	 *
	 * @return Ȗ񐔂̏l
	 */
	public int getMaxSteps() { return maxSteps; }

	/**
	 * _̏o͌`ݒ肷.
	 * FORMATLISTŒ`ꂽƕIɈv邱.
	 *
	 * @param s  _̏o͌` (v)
	 */
	public void setFormat(String s) {
		if (s != null && s.length() > 0) {
			List list = new ArrayList();
			for (int n = 0; n < FORMATLIST.length; n++) {
				String fmt = FORMATLIST[n];
				if (fmt.startsWith(s))
					list.add(fmt);
			}
			if (list.size() == 1) {
				initFormat((String)list.get(0));
				return;
			}
			if (list.size() >= 2)
				throw new IllegalArgumentException(AMBIGUOUS + arg(s));
		}
		throw new IllegalArgumentException(INVALARG + arg(s));
	}

	/**
	 * _̏o͌`p[^̐Ԃ.
	 *
	 * @param indent ̑OɒuCfg
	 */
	public String getFormatCaption(String indent) {
		String eol = System.getProperty("line.separator");
		StringBuffer sb = new StringBuffer();
		for (int n = 0; n < FORMATDESC.length; n++) {
			sb.append(indent).append(FORMATDESC[n]);
			if (n < FORMATDESC.length-1)
				sb.append(eol);
		}
		return sb.toString();
	}

	/**
	 * _̏o͂}Nɕϊ邩ǂݒ肷.
	 *
	 * @param value  trueȂΏo͂}Nɕϊ
	 */
	public void setReshape(boolean value) { useMacro = value; }

	/**
	 * C[^()ϊ}邩ǂ𐧌䂷.
	 *
	 * @param suppress trueȂ΃ŕϊ}
	 */
	public void suppressEtaConversion(boolean suppress) {
		LExpr.suppressEtaConversion(suppress);
	}

	/*--------------------------------------------------------------------*/

	/**
	 * _̂PXebvōȖ񏈗 -- ϊ
	 *
	 * ̃\bh͎Iȃϊreduce()Ăяoʂȃg[Xo
	 * }@\ǉ.
	 * K`̔reduce()̎sʂ null ǂŌ܂.
	 * ăg[Xo͂Ăꍇɂ͐K`ꂽ̍Ō
	 * g[Xʂł. ̖ʂȂߐVTraceInfog.
	 * ̃\bh͂łɐK`Ȃ΃g[Xo͂Ȃ.
	 *
	 * @param expr  ȖΏۂ̃_
	 * @return  PXebvȖ񌋉ʂ̃Xg (łɐK`Ȃnull)
	 */
	private LExpr reduce(LExpr expr) {
		TraceInfo trinf = TraceInfo.getInstance();
		if (trinf.isVerbose()) {
			trinf = trinf.push();
			if (expr.variableName() == null)
				trinf.appendTarget(expr, 0, "");
		}
		LExpr newexpr = expr.reduce();
		if (trinf.isVerbose()) {
			trinf.appendResult(newexpr, 0, "");
			trinf.pop(newexpr != null);
		}
		return newexpr;
	}

	/**
	 * _̂PXebvȖ񏈗 -- ϊ
	 *
	 * ̃\bh͎IȃϊreduceAll()Ăяoʂȃg[Xo
	 * }@\ǉ.
	 * K`̔reduceAll()̎sʂ̔z񂩂ǂŌ܂.
	 * ăg[Xo͂Ăꍇɂ͐K`ꂽ̍Ō
	 * g[Xʂł. ̖ʂȂߐVTraceInfog.
	 * ̃\bh͂łɐK`Ȃ΃g[Xo͂Ȃ.
	 *
	 * @param expr  ȖΏۂ̃_
	 * @return  PXebvȖ񌋉ʂ̔z
	 */
	private LExpr[] reduceAll(LExpr expr) {
		TraceInfo trinf = TraceInfo.getInstance();
		if (trinf.isVerbose()) {
			trinf = trinf.push();
			if (expr.variableName() == null)
				trinf.appendTarget(expr, 0, "");
		}
		LExpr array[] = expr.reduceAll();
		if (trinf.isVerbose()) {
			trinf.appendArray(array, 0, "");
			trinf.pop(array.length > 0);
		}
		return array;
	}

	/**
	 * LExpr^̃_ɕϊ.
	 */
	private LExpr toLExpr(String s) {
		LExpr expr = null;
		try {
			expr = (s.indexOf('[') >= 0)
				? factory.parseSubstitution(s) : factory.create(s);
		} catch (Exception ex) {
			throw new IllegalArgumentException(ex.getMessage() + arg(s));
		}
		return expr;
	}

	/**
	 * vZʂ̃_o͂.
	 */
	private void printLExpr(PrintWriter out, LExpr expr, String s) {
		boolean uselambda = usingLambda(s);
		String sval = (useMacro && s.indexOf(macroStart) >= 0)
			? converter.reshape(expr, uselambda)
			: expr.getString(format, uselambda);
		if (sval.indexOf(False) >= 0) {
			if (s.matches(Number))
				sval = sval.replaceAll(False, Zero);
		} else if (sval.indexOf(Zero) >= 0) {
			if (s.indexOf(True) >= 0 || s.indexOf(False) >= 0)
				sval = sval.replaceAll(Zero, False);
		}
		out.println(sval);
	}

	/**
	 * g[Xʂo͂.
	 *
	 * @param s ͂ꂽ_
	 * @param out g[Xo͐
	 */
	private void printTraceInfo(String s, PrintWriter out) {
		boolean uselambda = usingLambda(s);
		boolean convert = useMacro && s.indexOf(macroStart) >= 0;
		TraceInfo trinf = TraceInfo.getInstance();
		List list = trinf.getExprList();
		String array[] = new String[list.size()];
		for (int n = 0; n < list.size(); n++) {
			LExpr expr = ((LExpr)list.get(n)).reshape();
			array[n] = convert ? converter.reshape(expr, uselambda)
					: expr.getString(format, uselambda);
		}
		trinf.print(out, array);
		out.flush();
	}

	/**
	 * _̏o͌`ݒ肷.
	 */
	private void initFormat(String s) {
		format = s;
		converter.setFormat(s);
	}

	/**
	 * obNXbVł͂Ȃɂgďo͂ꍇtrueԂ.
	 */
	private boolean usingLambda(String s) {
		return s.indexOf('') >= 0;
	}

	/*--------------------------------------------------------------------*/

	/**
	 * }N`.
	 */
	private void define(String name, String value) {
		if (name == null)
			throw new IllegalArgumentException(NULLNAME);
		name = name.trim();
		if (name.length() <= 0)
			throw new IllegalArgumentException(EMPTYNAME);
		if (!isIdStart(name.charAt(0)))
			throw new IllegalArgumentException(INVALNAME + arg(name));
		for (int n = 1; n < name.length(); n++)
			if (!isIdPart(name.charAt(n)))
				throw new IllegalArgumentException(INVALNAME + arg(name));
		String xvalue = converter.expandMacros(value);
		LExpr expr = toLExpr(xvalue);  // @`FbN˂.
		converter.appendMacro(name, value, expr);
	}

	/**
	 * }N̐擪Ƃĉ\ȂtrueԂ.
	 * lƂɒ.
	 */
	private boolean isIdStart(int c) {
		return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z'
			|| '0' <= c && c <= '9';
	}

	/**
	 * }N̂Qڈȍ~Ƃĉ\ȂtrueԂ.
	 */
	private boolean isIdPart(int c) {
		return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z'
			|| '0' <= c && c <= '9';
	}

	/*--------------------------------------------------------------------*/

	/**
	 * LExprFactoryIuWFNg쐬.
	 * œn LExprConverter ̓}NWJ@\҂Ă.
	 *  null nƃ}N͓WJȂ.
	 *
	 * @param converter }NWJIuWFNg (nullȂ΃}NWJȂ)
	 * @param out IuWFNg쐬̃g[Xo͐ (nullȂ΃g[XȂ)
	 */
	private LExprFactory createFactory(LExprConverter converter,
			PrintWriter out) {
		String key = LExprFactory.class.getName() + ".class";
		String className = System.getProperty(key);
		if (className != null && className.length() > 0) {
			try {
				Class c = Class.forName(className);
				Constructor con = c.getConstructor(new Class[]{
					LExprConverter.class, PrintWriter.class
				});
				return (LExprFactory)con.newInstance(new Object[]{
					converter, out
				});
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		throw new IllegalStateException("check env");
	}

	/**
	 * LExprConverterIuWFNg쐬.
	 */
	private LExprConverter createConverter(String macroStart, String macroEnd) {
		String key = LExprConverter.class.getName() + ".class";
		String className = System.getProperty(key);
		if (className != null && className.length() > 0) {
			try {
				Class c = Class.forName(className);
				Constructor con = c.getConstructor(new Class[]{
					String.class, String.class
				});
				return (LExprConverter)con.newInstance(new Object[]{
					macroStart, macroEnd
				});
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		throw new IllegalStateException("check env");
	}

	/*--------------------------------------------------------------------*/

	/**
	 * G[bZ[Wɏǉ.
	 */
	private String arg(String s) { return ": \"" + s + "\""; }
}
