package mypkg.lambda;

import java.util.Map;
import java.util.LinkedHashMap;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Collections;
import java.io.PrintWriter;

/**
 * }N̊Ǘ
 *
 * }N@\ǉC^tF[X LExprConverter ̎NXł.
 *
 * ̃NX̖͎̂Ƃ.
 * E͂ꂽ_񂩂}NQƂo}NWJꂽ
 *   ɕϊ.
 * EvZʂ̃_}N̒lo}Nɒu邱
 *   ɂ莮₷.
 */
public class LExprShaper implements LExprConverter {

	private Map symtab;          // }Nƃ}Nl()̑Ή\
	private Map exprtab;         // }Nƃ}Nl(LExpr)̑Ή\
	private List infoList;       // List<MacroInfo>

	private String format;       // _̏o͌`

	private final String macroStart;   // }NQƂ̊JnL
	private final String macroEnd;     // }NQƂ̏IL

	private static final String Lambda = "\\";
	private static final String Succ = "s";
	private static final String Zero = "z";

	/**
	 * RXgN^
	 *
	 * @param macroStart }NQƂ̊JnL
	 * @param macroEnd }NQƂ̏IL
	 */
	public LExprShaper(String macroStart, String macroEnd) {
		this.macroStart = macroStart;
		this.macroEnd = macroEnd;
		this.symtab = new LinkedHashMap();
		this.exprtab = new HashMap();
		setFormat(System.getProperty(LExpr.DEFFORMATKEY, LExpr.ABBREVFORMAT));
	}

	/**
	 * _̏o͌`ݒ肷.
	 *
	 * @param s _̏o͌` (LExpr.getString()ɓn`)
	 */
	public void setFormat(String s) {
		format = s;
	}

	/**
	 * }NɊւǗ.
	 * }N̒lɃ}NQƂ܂܂Ă\z肵Ă.
	 */
	public void initMacros() {
		infoList = new ArrayList();
		for (Iterator i = symtab.keySet().iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			String value = (String)symtab.get(name);
			LExpr expr = (LExpr)exprtab.get(name);
			infoList.add(new MacroInfo(name, expand(value), expr));
		}
		Collections.sort(infoList);  // }ND悳.
	}

	/**
	 * }N̒ǉ
	 *
	 * @param name  }N
	 * @param value }N̒l
	 * @param expr  }N̒l̃_
	 */
	public void appendMacro(String name, String value, LExpr expr) {
		symtab.put(name, value);
		exprtab.put(name, expr);
	}

	/**
	 * }N̓WJ
	 *
	 * @param s }NQƂ܂ރ_
	 * @return }NWJꂽ_
	 */
	public String expandMacros(String s) {
		return expand(s);
	}

	/**
	 * }N`̈ꗗo͂.
	 *
	 * @param out o͐
	 * @param msg p (nullȂΏo͂Ȃ)
	 */
	public void printMacros(PrintWriter out, String msg) {
		if (symtab.size() <= 0)
			return;
		out.println();
		if (msg != null && msg.length() > 0)
			out.println(msg);
		for (Iterator i = symtab.keySet().iterator(); i.hasNext(); ) {
			String name = (String)i.next();
			String value = (String)symtab.get(name);
			out.println("\t" + name + "\t" + value);
		}
		for (int number = 0; number <= 5; number++) {
			String name = String.valueOf(number);
			String value = numberMacro(number);
			out.println("\t" + name + "\t" + value);
		}
		out.println("\t  EEEE");
		StringBuffer sb = new StringBuffer();
		sb.append(Lambda).append(Succ).append(Zero).append(".");
		sb.append(Succ).append("(").append(Succ);
		sb.append("(EEE(").append(Succ).append(Zero).append(")EEE))");
		out.println("\tn\t" + sb.toString());
		out.println("\t  EEEE");
		out.println();
	}

	/**
	 * LExpr^̃_ł邾}Ngɕϊ.
	 *
	 * @param expr _
	 * @param uselambda _LɃɂgꍇtrue, \ gꍇfalse
	 * @return ϊꂽ̃_
	 */
	public String reshape(LExpr expr, boolean uselambda) {
		LExpr newexpr = convert(expr);
		return newexpr.getString(format, uselambda);
	}

	/**
	 * }Nւ̕ϊ
	 * {IȐ헪̓}Nƈvm[hNXMacrõIuWFNg
	 * ɒuȂ^ꂽ_̃Rs[낤Ƃ.
	 */
	private LExpr convert(LExpr expr) {
		String mname = searchMacro(expr);
		if (mname != null)
			return new Macro(mname);
		if (expr.variableName() != null)
			return (LExpr)expr.clone();
		if (expr.parameterName() != null) {
			String param = expr.parameterName();
			LExpr e = expr.getBody();
			String macro = searchMacro(e);
			LExpr newexpr = (macro != null) ? new Macro(macro) : convert(e);
			return LExpr.getInstance(param, newexpr);
		}
		if (expr.getBodyOfRedex() != null) {
			LExpr body = convert(expr.getBodyOfRedex());
			String param = expr.getParamOfRedex();
			LExpr arg = convert(expr.getArgOfRedex());
			return LExpr.getInstance(body, param, arg);
		}
		LExpr left = expr.getFunction();
		String lmacro = searchMacro(left);
		LExpr newleft = (lmacro != null) ? new Macro(lmacro) : convert(left);
		LExpr right = expr.getArgument();
		String rmacro = searchMacro(right);
		LExpr newright = (rmacro != null) ? new Macro(rmacro) : convert(right);
		return LExpr.getInstance(newleft, newright);
	}

	/**
	 * }NWJ.
	 */
	private String expand(String s) {
		int start = s.indexOf(macroStart);
		if (start < 0)
			return s;
		int end = s.indexOf(macroEnd, start + macroStart.length());
		if (end < 0) {
			String msg = "\"" + macroEnd + "\" expected";
			throw new IllegalArgumentException(msg);
		}
		String name = s.substring(start + macroStart.length(), end);
		String value = (String)symtab.get(name);
		if (value == null) {
			if ((value = numberMacro(name)) == null) {
				String msg = "undefined macro: \"" + name + "\"";
				throw new IllegalArgumentException(msg);
			}
		}
		StringBuffer sb = new StringBuffer();
		sb.append(s.substring(0, start)).append("(").append(value).append(")");
		sb.append(s.substring(end + macroEnd.length()));
		return expand(sb.toString());
	}

	/**
	 * w̃_}N`ƈvȂ΃}NԂ.
	 */
	private String searchMacro(LExpr expr) {
		for (int n = 0; n < infoList.size(); n++) {
			MacroInfo info = (MacroInfo)infoList.get(n);
			if (info.match(expr))
				return info.getName();
		}
		int number = getNumber(expr);
		if (number >= 0)
			return String.valueOf(number);
		return null;
	}

	/**
	 * w̕񂪐lȂΑΉ郉_Ԃ.
	 *     0 = sz.z
	 *     1 = sz.sz
	 *     2 = sz.s(sz)
	 *     3 = sz.s(s(sz))
	 */
	private String numberMacro(String s) {
		int number = 0;
		try {
			number = Integer.parseInt(s);
		} catch (NumberFormatException e) {
			return null;  // lł͂Ȃ.
		}
		return numberMacro(number);
	}

	/**
	 * w̐lɑΉ郉_Ԃ.
	 */
	private String numberMacro(int number) {
		StringBuffer sb = new StringBuffer();
		sb.append(Lambda).append(Succ).append(Zero).append(".");
		for (int n = 0; n < number; n++) {
			if (n >= 1)
				sb.append("(");
			sb.append(Succ);
		}
		sb.append(Zero);
		for (int n = 1; n < number; n++)
			sb.append(")");
		return sb.toString();
	}

	/**
	 * w̃_ sz.s(s(EEE(sz)EEE)) ȂΑΉ鐔lԂ.
	 *     0 = sz.z
	 *     1 = sz.sz
	 *     2 = sz.s(sz)
	 *     3 = sz.s(s(sz))
	 */
	private int getNumber(LExpr expr) {
		try {
			return expr.getChurchNumeral(null, null);
		} catch (IllegalStateException e) {
		}
		return -1;
	}

	/**
	 * }NɊւǗ
	 */
	private class MacroInfo implements Comparable {
		private String name;    // }N
		private String value;   // }N̒l (String)
		private LExpr expr;     // }N̒l (LExpr)
		MacroInfo(String name, String value, LExpr expr) {
			this.name = name;
			this.value = value;
			this.expr = expr;
		}
		boolean match(LExpr e) {
			return expr.isAlphaEquivalent(e);
		}
		String getName() { return name; }
		public int compareTo(Object obj) {
			MacroInfo arg = (MacroInfo)obj;
			// }ND悳.
			return arg.value.length() - this.value.length();
		}
	}

	/**
	 * }Nƈvm[huLExpr̃TuNX
	 */
	private class Macro extends LExpr {
		private String name;
		Macro(String name) {
			this.name = name;
		}
		public Object clone() {
			Macro newexpr = null;
			try {
				newexpr = (Macro)super.clone();
			} catch (Exception e) {
				// assert false;
			}
			newexpr.name = this.name;
			return newexpr;
		}
		protected String toAbbrevString(boolean uselambda) {
			return macroStart + name + macroEnd;
		}
		protected String toMathString(boolean uselambda) {
			return macroStart + name + macroEnd;
		}
		protected String toProperString(boolean uselambda) {
			return macroStart + name + macroEnd;
		}
	}
}
