package mypkg.lambda;

import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.PrintWriter;

/**
 * 񂩂烉_ւ̕ϊ
 *
 * 񂩂烉_ւ̕ϊC^tF[X LExprFactory ̎NXł.
 *
 * wIɕ\ꂽ̃__IuWFNgɕϊ.
 * wIȕ\Ƃ
 *     x | x.e | e1e2 | EEE
 * ̂悤ȕӖ.
 *
 * ϐ̋؂𖾊mKv邽
 *     ϐ : [a-zA-Z][0-9]*
 * Ƃ.
 *
 * _̐wI\ɂĂ͉L̊Kɏ].
 *
 *                             l
 *   ------------------------------------------------------------------
 *     x.y.e  x.(y.e)  ϐ֐I xy.e ƏĂ
 *     x.e1e2   x.(e1e2)   ֐Kp̓_ۂD揇ʂ
 *     e1e2e3     (e1e2)e3     ֐Kp͍
 */
public class MathLExprFactory implements LExprFactory {

	private LExprConverter converter;  // }NWJp
	private PrintWriter out;           // g[X̏o͐

	private static final String
		INVAL_CHAR = "invalid char",
		INVAL_ABS = "invalid abstraction",
		WRONG = "invalid syntax",
		EXP_RPAREN = "invalid syntax -- \")\" expected",
		UNEXP_EOF = "unexpected EOF";

	/**
	 * RXgN^
	 *
	 * @param converter }NWJpIuWFNg (nullȂ΃}NWJ)
	 * @param out g[X̏o͐ (nullȂ΃g[XȂ)
	 */
	public MathLExprFactory(LExprConverter converter, PrintWriter out) {
		this.converter = converter;
		this.out = out;
	}

	/**
	 * ^ꂽ񂩂烉_(LExpr^)쐬.
	 *
	 * @param s ϊΏۂ̕
	 * @return 쐬ꂽ_
	 */
	public LExpr create(String s) {
		if (s == null || s.length() <= 0)
			return null;  // empty
		return createLExpr(s, out);
	}

	/**
	 * M[x:=N] ܂ [N/x]M ̌`̕߂ă_쐬.
	 * Ԃ̂͑Zʂ̃_ł͂ȂƂɒ.
	 *
	 * @param s ϊΏۂ̕
	 * @return 쐬ꂽ_ (-redex\_)
	 */
	public LExpr parseSubstitution(String s) {
		String ms = null, ns = null, param = null;
		if (s != null && s.length() > 0) {        // M[x:=N]
			if (s.charAt(s.length()-1) == ']') {
				int p1 = s.indexOf('[');
				if (p1 >= 0) {
					int p2 = s.indexOf(":=");
					if (p2 >= 0) {
						ms = s.substring(0, p1).trim();
						param = s.substring(p1+1, p2).trim();
						ns = s.substring(p2+2, s.length()-1).trim();
					}
				}
			} else if (s.charAt(0) == '[') {      // [N/x]M
				int p1 = s.indexOf('/');
				if (p1 >= 0) {
					int p2 = s.indexOf(']');
					if (p2 >= 0) {
						ns = s.substring(1, p1).trim();
						param = s.substring(p1+1, p2).trim();
						ms = s.substring(p2+1).trim();
					}
				}
			}
		}
		if (ms == null || ns == null || param == null)
			throw new IllegalArgumentException();
		LExpr body = createLExpr(ms, out);
		LExpr arg = createLExpr(ns, out);
		return LExpr.getInstance(body, param, arg);
	}

	/**
	 * ^ꂽ񂩂烉_(LExpr^)쐬.
	 *
	 * @param s ϊΏۂ̕
	 * @return 쐬ꂽ_ (̃_蓾.)
	 */
	private LExpr createLExpr(String s, PrintWriter out) {
		if (converter != null)
			s = converter.expandMacros(s);
		Tokenizer t = new Tokenizer(s, out);
		LExpr expr = readLExpr(t);
		String token = t.getToken();
		if (token != null)
			invalid(WRONG + ": " + token);
		return expr;
	}

	/*------------------------------------------------------------------*/
	// \

	/**
	 * _IuWFNgԂ.
	 *
	 * @return _ (g[NȂꍇnull蓾.)
	 */
	private LExpr readLExpr(Tokenizer t) {
		LExpr expr = null;
		for (String token = null; (token = t.getToken()) != null; ) {
			LExpr e = null;
			if (token.equals("(")) {
				// ʂ̏ꍇ͍ċAĂяo
				if ((e = readLExpr(t)) == null)
					invalid(WRONG);
				if (!")".equals(t.getToken()))
					invalid(EXP_RPAREN);
			} else if (token.equals(")")) {
				// Eʂ̏ꍇ͕A
				t.pushback(token);
				break;
			} else if (token.equals(LExpr.LAMBDA)) {
				// g[N_L̏ꍇ --  x.e
				e = getAbstraction(t);
			} else if (isVarString(token)) {
				// g[Nϐ̏ꍇ --  x, e12
				e = LExpr.getInstance(token);
			} else {
				// LȊO̓V^NXG[
				invalid(WRONG + ": " + token);
			}
			// ֐KpIɌ. --  (e1e2)e3
			expr = (expr == null) ? e : LExpr.getInstance(expr, e);
		}
		return expr;
	}

	/**
	 * _(Abstraction^)IuWFNgԂ.
	 *
	 * _Lǂ񂾎ԂŌĂяo. ϐ
	 * ֐(xy.eȂ)̏ꍇ̓_Lǂ񂾂Ƃ݂ȂČĂяo.
	 *
	 *  x.e
	 *    x.y.e -> x.(y.e)
	 *    xyz.e -> (x.(y.(z.e)))
	 */
	private LExpr getAbstraction(Tokenizer t) {
		String param = t.getToken();
		if (param == null)
			invalid(UNEXP_EOF);
		String token = t.getToken();
		if (!".".equals(token)) {
			if (isVarString(token)) {
				t.pushback(token);
				// ϐ֐ xyz.e -> (x.(y.(z.e)))
				return LExpr.getInstance(param, getAbstraction(t));
			}
			invalid(INVAL_ABS);
		}
		LExpr expr = readLExpr(t);
		if (expr == null)
			invalid(INVAL_ABS);
		return LExpr.getInstance(param, expr);
	}

	/**
	 * w̃g[NϐȂtrueԂ.
	 */
	private boolean isVarString(String token) {
		if (token == null || token.length() <= 0)
			return false;
		return LExpr.isVariableStart(token.charAt(0));
	}

	/**
	 * @ᔽ̗OX[.
	 */
	private void invalid(String msg) {
		throw new IllegalArgumentException(msg);
	}

	/*------------------------------------------------------------------*/

	/**
	 * ͂𕪒SNX
	 */
	private class Tokenizer {

		private String string;
		private int offset;
		private int length;
		private String unget_token;
		private PrintWriter trout;

		/**
		 * RXgN^
		 */
		Tokenizer(String s, PrintWriter out) {
			string = s;
			offset = 0;
			length = s.length();
			unget_token = null;
			trout = out;
		}

		/**
		 * g[NԂ.
		 *  [] EOF, "", "(", ")", ".", "x", "e12"
		 */
		String getToken() {
			String token = separate();
			if (trout != null)
				trout.println("#token: " + token);
			return token;
		}

		/**
		 * g[N߂.
		 */
		void pushback(String token) {
			if (trout != null)
				trout.println("#pushback: " + token);
			unget_token = token;
		}

		/**
		 * ͌`̕ϐ
		 *     [a-zA-Z][0-9]*
		 * łȂ΂ȂȂ. ܂pPɐA
		 * ݂̂. ͐wI\̊Ȍ߂邽߂̐ł.
		 * Iɍ쐬ϐ͈قȂƂȂ.
		 */
		private String separate() {
			if (unget_token != null) {
				String token = unget_token;
				unget_token = null;
				return token;
			}
			int c = -1;
			while ((c = getChar()) >= 0 && isBlank(c))
				;
			if (c < 0)
				return null;  // EOF
			if (c == LExpr.LAMBDA.charAt(0) || "().".indexOf(c) >= 0)
				return String.valueOf((char)c);
			if (c == '\\')
				return LExpr.LAMBDA;  // ͂̕֋X}.
			if (!LExpr.isVariableStart(c))
				invalid(INVAL_CHAR + ": " + String.valueOf((char)c));
			// ϐ̏ꍇ
			StringBuffer sb = new StringBuffer(String.valueOf((char)c));
			while ((c = getChar()) >= 0 && Character.isDigit((char)c))
				sb.append((char)c);
			if (c >= 0)
				ungetChar(c);
			return sb.toString();
		}

		private boolean isBlank(int c) {
			return c == ' ' || c == '\t' || c == '\n' || c == '\r';
		}

		private int getChar() {
			if (offset >= length)
				return -1;
			return string.charAt(offset++);
		}

		private void ungetChar(int c) {
			if (c >= 0 && offset > 0)
				offset--;
		}
	}

	/*------------------------------------------------------------------*/

	/**
	 * ZteXg
	 */
	public static void main(String argv[]) {
		String format = System.getProperty(LExpr.DEFFORMATKEY);
		boolean verbose = false;
		for (int n = 0; n < argv.length; n++) {
			String s = argv[n];
			if (s.equals("-v")) {
				verbose = true;
				continue;
			}
			if (s.charAt(0) == '-') {
				String name = MathLExprFactory.class.getName();
				System.err.println("[Usage] java " + name + " [-v] format");
				System.err.print("  format:");
				System.err.print(" " + LExpr.MATHFORMAT);
				System.err.print(" " + LExpr.PROPERFORMAT);
				System.err.println();
				return;
			}
			format = s;
		}

		MathLExprFactory factory = new MathLExprFactory(null, null);
		PrintWriter out = new PrintWriter(System.out, true);
		BufferedReader in =
			new BufferedReader(new InputStreamReader(System.in));
		boolean prompt = false;
		try {
			prompt = !in.ready();
		} catch (Exception e) {
			return;
		}
		if (prompt)
			System.err.println("# format=" + format);
		String endMark = ";";
		for ( ; ; ) {
			try {
				if (prompt)
					System.err.print("? ");
				String s = in.readLine();
				if (s == null)
					break;
				s = s.trim();
				if (s.length() <= 0)
					continue;
				if (s.endsWith(endMark))
					s = s.substring(0, s.length()-endMark.length());
				LExpr expr = factory.create(s);
				out.println(expr.getString(format, s.indexOf('') >= 0));
			} catch (Exception e) {
				System.err.println(e.getMessage());
			}
		}
		if (prompt)
			System.err.println();
	}
}
