package mypkg.lambda;

import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;
import java.util.LinkedList;

/**
 * ϐ -- _LExpr̊gNX
 *
 * _Ƃ
 *     ϐ | _ | ֐Kp
 * ł, ̃NX͕ϐ\.
 * ̃NX̃IuWFNg̓_c[ŕ\ꍇ̃[tm[h
 * ƂȂ.
 */
public class Variable extends LExpr {

	private String name;  // ϐ

	/**
	 * RXgN^
	 *
	 * @param name ϐ
	 */
	public Variable(String name) {
		if (!checkVariable(name))
			throw new IllegalArgumentException("invalid variable: " + name);
		this.name = name;
	}

	/**
	 * ̃IuWFNg̃Rs[Ԃ.
	 */
	public Object clone() {
		Variable newexpr = null;
		try {
			newexpr = (Variable)super.clone();
		} catch (Exception e) {
			// assert false;
		}
		newexpr.name = this.name;
		return newexpr;
	}

	/**
	 * RϐW߂.
	 */
	protected void gatherFreeVars(Set set) {
		set.add(name);
	}

	/**
	 * ̃IuWFNgϐȂ΂̖OԂ.
	 */
	protected String variableName() {
		return name;
	}

	/**
	 *  M[x:=N]
	 *
	 * M  x  N l M 
	 *     ϐ, _, ֐Kp
	 * ̏ꍇɕċ߂.
	 * ̒` (vO~O̊b_ x~ p.18)
	 *
	 *        `                           
	 *   -----------------------------------------------------------------
	 *   (a)  x[x:=N]                            N
	 *   (b)  y[x:=N]        xy                y
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (c)  (y.M)[x:=N]  xy                y.M
	 *   (d)  (y.M)[x:=N]  xy y ! FV(N)    y.M[x:=N]        [1]
	 *   (e)  (y.M)[x:=N]  LȊO            z.M[y:=z][x:=N]  [2]
	 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	 *   (f)  (M1M2)[x:=N]                       M1[x:=N]M2[x:=N]
	 *   -----------------------------------------------------------------
	 *
	 *  [1] y ! FV(N)  y  N ̎Rϐł͂ȂƂӖ.
	 *  [2] IɃϊ邱Ƃɒ. ϐ z ͂܂VO
	 *        I΂.
	 *
	 * @param param ɑϐ (x)
	 * @param arg   ɑ郉_ (N)
	 * @param level ċAďox
	 * @return  Zʂ̒l
	 */
	protected LExpr substitute(String param, LExpr arg, int level) {
		//########## (a) x[x:=N]  N ##########
		//########## (b) y[x:=N]  y ##########
		return param.equals(name) ? arg : this;
	}

	/**
	 * ̃IuWFNg̃IuWFNgƃlȂtrueԂ.
	 */
	protected boolean isEquivalent(LExpr expr, LinkedList stack, int level) {
		if (!(expr instanceof Variable))
			return false;
		String exprname = ((Variable)expr).name;
		for (int n = 0; n < stack.size(); n++) {
			String param[] = (String[])stack.get(n);
			boolean eqx = param[0].equals(name);
			boolean eqy = param[1].equals(exprname);
			if (eqx && eqy)
				return true;   // ϐƂē.
			if (eqx != eqy)
				return false;  // ϐƎRϐ
		}
		if (name.equals(exprname))
			return true;  // RϐƂē.
		return false;
	}

	/**
	 * _̂PXebvōȖ񏈗 -- ϊ
	 * ϐ͂łɐK`ŊȖłȂ̂ł̃NXłnullԂ.
	 */
	protected LExpr reduce(int level) {
		return null;
	}

	/**
	 * _̂PXebvȖ񏈗 -- ϊ
	 * ϐ͊ȖłȂ̂ł̃NXł͋󃊃XgԂ.
	 */
	protected List reduceAll(int level) {
		return new ArrayList();    // ϐ͊ȖłȂ.
	}

	/**
	 * łȌȐwI\̕Ԃ.
	 *  xyz.xyz
	 */
	protected String toAbbrevString(boolean uselambda) {
		return name;
	}

	/**
	 * ȌȐwI\̕Ԃ.
	 *  x.y.z.xyz
	 */
	protected String toMathString(boolean uselambda) {
		return name;
	}

	/**
	 * 璷ȐwI\̕Ԃ.
	 *  x.(y.(z.((xy)z)))
	 */
	protected String toProperString(boolean uselambda) {
		return name;
	}

	/**
	 * RϐϐʂׂĂ̕ϐW߂.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void gatherVars(Set set) {
		set.add(name);
	}

	/**
	 * Ή\QƂĕϐu.
	 * ϊŕtꂽOu邽߂̕⏕Iȋ@\.
	 */
	protected void replaceVars(Map map) {
		String newname = (String)map.get(name);
		if (newname != null)
			name = newname;
	}
}
