package mypkg.lambda.util;

import java.util.Properties;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.Reader;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileNotFoundException;

/**
 * vpeB̑NX
 */
public class PropertiesHandler {

	/**
	 * vpeB̎擾
	 *
	 * ̃\bh, ܂ꂽvpeBt@CvpeBǂ
	 * . Ɏw肪, [U쐬̃vpeBt@Cǂݍ
	 * vpeBŏ㏑.
	 *
	 * ꂽt@C getResourceAsStream() ŃI[v\ȖOw
	 * Ȃ΂ȂȂ. ɓe̓jR[hGXP[vĂ邱.
	 *
	 * [U쐬̃t@C͕ҏW₷lălCeBuGR[fBO
	 * ŏĂ邱Ƃ肷. ̃NX createFile() g, 
	 * ͖.
	 *
	 * @param bundledfile JARt@CɓꂽvpeBt@C
	 * @param userfile [U쐬̃vpeBt@C
	 * @return }[WꂽvpeB
	 */
	public Properties getProperties(String bundledfile, String userfile)
			throws IOException {
		Properties p = new Properties();
		InputStream is = getClass().getResourceAsStream(bundledfile);
		if (is != null) {
			try {
				p.load(is);  // jart@C̃vpeBt@C
			} finally {
				is.close();
			}
		}
		if (userfile != null) {
			InputStream fis = new NativeToAscii(userfile);
			try {
				p.load(fis);  // [U`̃vpeBt@C
			} finally {
				fis.close();
			}
		}
		return p;
	}

	/**
	 * [UvpeBt@C̍쐬
	 *
	 * ̃\bh̓ftHg̃vpeBt@C̃Rs[쐬邱Ƃ
	 * , [U쐬̃vpeBt@Č^Ƃ邱ƂӐ}Ă.
	 *
	 * QƂt@C getResourceAsStream() ŃI[v\ȖOw
	 * Ȃ΂ȂȂ. ɓe̓jR[hGXP[vĂ邱.
	 *
	 * 쐬t@C, [UɂҏWeՂȂ悤, lCeBuG
	 * R[fBOŏ܂.
	 *
	 * @param bundledfile QƂvpeBt@C
	 * @param userfile 쐬vpeBt@C
	 * @param msg  t@C̐擪ɏ܂Rg
	 */
	public void createFile(String bundledfile, String userfile, String msg[])
			throws IOException {
		InputStream is = getClass().getResourceAsStream(bundledfile);
		if (is == null)
			throw new FileNotFoundException("resource: " + bundledfile);
		BufferedReader in = null;
		PrintWriter out = null;
		try {
			in = new BufferedReader(new ResourceReader(is));
			out = new PrintWriter(new FileWriter(userfile));
			if (msg != null) {
				for (int n = 0; n < msg.length; n++) {
					out.print("# ");
					out.println(msg[n]);
				}
				out.println();
			}
			for ( ; ; ) {
				String line = in.readLine();
				if (line == null)
					break;
				if (line.length() > 0 && line.charAt(0) != '#')
					out.print("#");
				out.println(line);
			}
			out.flush();
		} finally {
			if (out != null) out.close();
			if (in != null) in.close();
		}
	}

	private class NativeToAscii extends InputStream {

		private byte buf[];  // ῗׂ̕ASCII
		private int offset;

		NativeToAscii(String file) throws IOException {
			this(new FileInputStream(file), (int)file.length() * 3);
		}

		NativeToAscii(InputStream is, int bufsize) throws IOException {
			try {
				String enc = System.getProperty("file.encoding");
				buf = toEscape(new InputStreamReader(is, enc), bufsize);
			} catch (Exception e) {
				String enc = "JISAutoDetect";
				buf = toEscape(new InputStreamReader(is, enc), bufsize);
			}
			offset = 0;
		}

		public int read() throws IOException {
			return (offset < buf.length)? buf[offset++] : -1;
		}

		private byte[] toEscape(Reader r, int bufsize) throws IOException {
			ByteArrayOutputStream baos =
				new ByteArrayOutputStream((bufsize > 0) ? bufsize : 4096);
			BufferedReader in = (r instanceof BufferedReader)
				? (BufferedReader)r : new BufferedReader(r);
			for (int c = -1; (c = in.read()) != -1; ) {
				if (c < 0x80) {
					baos.write(c);
				} else {
					baos.write('\\');
					baos.write('u');
					baos.write(toHex(c >> 12 & 0xf));
					baos.write(toHex(c >> 8 & 0xf));
					baos.write(toHex(c >> 4 & 0xf));
					baos.write(toHex(c & 0xf));
				}
			}
			return baos.toByteArray();
		}

		private int toHex(int c) { return (c <= 9) ? c + '0' : c - 10 + 'a'; }
	}
}
