package mypkg.lambda.util;

import java.io.InputStream;
import java.io.Reader;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.text.MessageFormat;

/**
 * \[XǍݗpReader
 *
 * ̃NX̓jR[hGXP[vꂽ`̃\[Xǂݍ.
 * \[X native2ascii ɂĕϊJARt@CɓĂ
 * ̂Ɖ肷.
 * g̗.
 *
 *     String bundledfile = EEE
 *     BufferedReader in = new BufferedReader(new ResourceReader(bundledfile));
 *     for ( ; ; ) {
 *         String line = in.readLine();
 *         if (line == null)
 *             break;
 *         // 
 *     }
 */
public class ResourceReader extends Reader {

	private char buffer[];
	private int pointer;

	/**
	 * RXgN^
	 *
	 * @param resource \[X
	 * @param args  (MessageFormat̎dl)
	 */
	public ResourceReader(String resource, Object args[]) throws IOException {
		InputStream is = getClass().getResourceAsStream(resource);
		if (is == null)
			throw new FileNotFoundException("resource: " + resource);
		try {
			if (args != null && args.length <= 0)
				args = null;
			buffer = toUnicode(new InputStreamReader(is, "8859_1"), args);
			pointer = 0;
		} finally {
			is.close();
		}
	}

	/**
	 * RXgN^
	 *
	 * @param resource \[X
	 */
	public ResourceReader(String resource) throws IOException {
		this(resource, null);
	}

	/**
	 * RXgN^
	 *
	 * @param is ͂InputStream
	 * @param args  (MessageFormat̎dl)
	 */
	public ResourceReader(InputStream is, Object args[]) throws IOException {
		if (args != null && args.length <= 0)
			args = null;
		buffer = toUnicode(new InputStreamReader(is, "8859_1"), args);
		pointer = 0;
	}

	/**
	 * RXgN^
	 *
	 * @param is ͂InputStream
	 */
	public ResourceReader(InputStream is) throws IOException {
		this(is, null);
	}

	/**
	 * N[Y
	 */
	public void close() throws IOException { buffer = null; }

	/**
	 * obt@֓͂.
	 */
	public int read(char cbuf[], int off, int len) throws IOException {
		int rest = buffer.length - pointer;
		if (rest <= 0)
			return -1;
		int size = (rest < len) ? rest : len;
		System.arraycopy(buffer, pointer, cbuf, off, size);
		pointer += size;
		return size;
	}

	/**
	 * P͂ĕԂ.
	 */
	public int read() throws IOException {
		return (pointer < buffer.length) ? buffer[pointer++] : -1;
	}

	/**
	 * jR[hGXP[vꂽjR[hɕϊ.
	 *
	 * @param r ͂Reader
	 * @return jR[h̔z
	 */
	private char[] toUnicode(Reader r, Object args[]) throws IOException {
		StringBuffer sb = new StringBuffer();
		String eol = System.getProperty("line.separator");
		BufferedReader in = (r instanceof BufferedReader)
			? (BufferedReader)r : new BufferedReader(r);
		/*
		 * sPʂŏĂ̂ŉsR[h͎sVXẽR[hƂȂ.
		 */
		for (String line = null; (line = in.readLine()) != null; ) {
			String s = toUnicode(line);
			if (args != null && line.indexOf('{') >= 0)
				s = MessageFormat.format(s, args);
			sb.append(s).append(eol);
		}
		return sb.toString().toCharArray();
	}

	/**
	 * jR[hGXP[vꂽjR[hɕϊ.
	 *
	 * @param s jR[hGXP[v܂ޕ
	 * @return jR[h
	 */
	private String toUnicode(String s) {
		StringBuffer sb = new StringBuffer();
		for (int len = s.length(), n = 0; n < len; n++) {
			char c1 = s.charAt(n);
			if (c1 != '\\' || n+5 >= len) {
				sb.append(c1);
				continue;
			}
			char c2 = s.charAt(++n);
			if (c2 != 'u') {
				sb.append(c1).append(c2);
				continue;
			}
			int value = getValue(s, n+1);
			if (value < 0) {
				sb.append(c1).append(c2);
			} else {
				sb.append((char)value);
				n += 4;
			}
		}
		return sb.toString();
	}

	/**
	 * wʒuSȏ゠邱Ƃ͌ďoŕۏ؂邱.
	 */
	private int getValue(String s, int off) {
		int value = 0;
		for (int end = off + 4; off < end; off++) {
			char c = s.charAt(off);
			if ('0' <= c && c <= '9')
				value = (value << 4) + c - '0';
			else if ('a' <= c && c <= 'f')
				value = (value << 4) + c - 'a' + 10;
			else if ('A' <= c && c <= 'F')
				value = (value << 4) + c - 'A' + 10;
			else
				return -1;
		}
		return value;
	}
}
